Search results

Markdown in JavaScript (ES5) RichTextEditor control

28 Mar 2023 / 11 minutes to read

When you format the word in Markdown format, you should add Markdown syntax to the word to indicate the words and phrases that looks different from each other.

Rich Text Editor supports markdown editing when the editorMode set as markdown and using both keyboard interaction and toolbar action, you can apply the formatting to text.

To create Rich Text Editor with Markdown editing feature, inject the MarkdownEditor module to the Rich Text Editor using the RichTextEditor.Inject(MarkdownEditor) method.

Supported Commands

The Javascript Markdown editor supports the following commands to format the markdown content:

Commands Syntax Description
Bold Sample content for **bold text**. For bold, add ** or __ to front and back of the text.
Italic Sample content for *Italic text*. For Italic, add * or _ to front and back of the text.
Bold and Italics Sample content for ***bold and Italic text***. For bold and Italics, add *** to the front and back of the text.
Heading 1 # Heading 1 content For heading 1, add # to start of the line.
Heading 2 ## Heading 2 content For heading 2, add ## to start of the line.
Heading 3 ### Heading 3 content For heading 3, add ### to start of the line.
Heading 4 #### Heading 4 content For heading 4, add #### to start of the line.
Heading 5 ##### Heading 5 content For heading 5, add ##### to start of the line.
Heading 6 ###### Heading 6 content For heading 6, add ###### to start of the line.
Line Break First line <br>Second line For line break, press enter two times (or) add <br> in between the first and the second line.
Blockquotes > Blockquotes text For blockquotes, add > to start of the line.
Strike Through Sample content for ~~strike through text~~. For strike through, add ~~ to front and back of the text.
Code (Single line) `Single line code` For single line code, add ` to front and back of the text.
Code block (Multi Line) ```
Multi line code text
Multi line code text
```
For multiple line code, add ``` in the new line before and after the content.
Subscript <sub>Subscript text</sub> For subscript, add <sub> to the front and </sub> to the back of the text.
Superscript <sup>Superscript text</sup> For superscript, add <sup> to the front and </sup> to the back of the text.
Ordered List 1. First
1. Second
For ordered list, preceding one or more lines of text with 1.
Unordered List * First
* second
For unordered list, preceding one or more lines of text with *.
Links Link text without title text
[ Link text ](URL)
Link text with title text
[ Link text ](URL , “title text”)
Create an inline link by wrapping link text in brackets [ ], and then wrapping the URL as first parameter and title as second parameter in the parentheses ().
Note: The title text is optional, if needed it can be given manually.
Table | Heading 1 | Heading 2 |
|---------|---------|
| Col A1 | Col A2 |
| Col B1 | Col B2 |
Create a table using the pipes and underscores as given in the syntax to create 2 x 2 table.
Horizontal Line *** (three asterix in new line)
(or)
___ (three underscores in new line)
For horizontal line, add *** or ___ to the start of the new line.
Image ![](URL path) Create an image by wrapping the image source in parentheses ().
Image with alternate text ![ alternate text ](URL path) Create an image with alternate text by wrapping an alternative text in brackets [], and then link of the image source in parentheses ().
Note: When inserting the image using toolbar, the alternate text cannot be provided that needs to be given manually.
Escape tick marks supported Sample text content with **bold and **not bold** text can be in the same line.** In the syntax, the whole content is made as bold where the content not bold can be made as normal text by adding the bold syntax to the start and end of the respective text. Likewise you can do the same for various inline commands.
Escape Character \(any syntax) Escape any markdown syntax by prefix \ to the syntax.
Example:
\**Bold text**
HTML Entities Copyright: © - &copy;
Trade mark: ™ - &trade;
Registered: ® - &reg;
Ampersand: & - &amp;
Less than: < - &lt;
Greater than: > - &gt;
For HTML entities, add & and ; to the front and back of the respective entities.

The above listed commands alone are supported in Syncfusion Markdown editor. For other unsupported commands, you can achieve using the HTML tags in Markdown editor. The foot notes, definitions, math, and check list markdown syntax are also not supported.

Markdown to HTML

The Rich Text Editor allows you to preview markdown changes immediately using preview. In this sample, the third-party library Marked is used to convert markdown into HTML content.

This sample demonstrates how to preview markdown changes in Rich Text Editor. Type or edit the display text, and apply format to view the preview of markdown. The actionComplete event can be used to convert Markdown to HTML.

This sample demonstrates how to preview markdown changes in Rich Text Editor. Type or edit the display text and apply format to view the preview of markdown.

Source
Preview
index.js
index.html
Copied to clipboard
/**
 * Rich Text Editor Markdown Preview Sample
 */
ej.base.enableRipple(true);

var textArea;
var mdsource;
var mdSplit;
var htmlPreview;

var defaultRTE = new ej.richtexteditor.RichTextEditor({
    height: 340, editorMode: 'Markdown',
    toolbarSettings: {
        items: ['Bold', 'Italic', 'StrikeThrough', '|', 'Formats', 'OrderedList', 'UnorderedList', '|', 'CreateLink', 'Image', '|',
            { tooltipText: 'Preview', template: '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn">' +
                    '<span class="e-btn-icon e-md-preview e-icons"></span></button>' }, '|', 'Undo', 'Redo']
    },
    created: function () {
        textArea = defaultRTE.contentModule.getEditPanel();
        textArea.addEventListener('keyup', function (e) { markDownConversion(); });
        var rteObj = defaultRTE;
        mdsource = document.getElementById('preview-code');
        mdsource.addEventListener('click', function (e) {
            fullPreview({ mode: true, type: 'preview' });
            if (e.currentTarget.classList.contains('e-active')) {
                defaultRTE.disableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
                    'Formats', 'OrderedList', 'UnorderedList', '|',
                    'CreateLink', 'Image', 'Undo', 'Redo']);
            }
            else {
                defaultRTE.enableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
                    'Formats', 'OrderedList', 'UnorderedList', '|',
                    'CreateLink', 'Image', 'Undo', 'Redo']);
            }
        });
    },
});
defaultRTE.appendTo('#defaultRTE');

function markDownConversion() {
    if (mdsource.classList.contains('e-active')) {
        var id = defaultRTE.getID() + 'html-preview';
        var htmlPreview_1 = defaultRTE.element.querySelector('#' + id);
        var rteElement = defaultRTE.contentModule.getEditPanel();
        var rteValue = rteElement.value;
        htmlPreview.innerHTML = marked(defaultRTE.contentModule.getEditPanel().value);
    }
}

function fullPreview(e) {
    var id = defaultRTE.getID() + 'html-preview';
    htmlPreview = defaultRTE.element.querySelector('#' + id);
    if (mdsource.classList.contains('e-active')) {
        mdsource.classList.remove('e-active');
        mdsource.parentElement.title = 'Preview';
        textArea.style.display = 'block';
        textArea.style.width = '100%';
        htmlPreview.style.display = 'none';
    }
    else {
        mdsource.classList.add('e-active');
        if (!htmlPreview) {
            htmlPreview = ej.base.createElement('div', { className: 'e-content' });
            htmlPreview.id = id;
            textArea.parentNode.appendChild(htmlPreview);
        }
        if (e.type === 'preview') {
            textArea.style.display = 'none';
            htmlPreview.classList.add('e-pre-source');
        }
        else {
            htmlPreview.classList.remove('e-pre-source');
            textArea.style.width = '50%';
        }
        htmlPreview.style.display = 'block';
        markDownConversion();
        mdsource.parentElement.title = 'Code View';
    }
}
Copied to clipboard
<!DOCTYPE html><html lang="en"><head>
            
    <title>Essential JS 2 Rich Text Editor</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-base/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-richtexteditor/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-lists/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-navigations/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-popups/styles/material.css" rel="stylesheet">
     <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    
    
   
<script src="https://cdn.syncfusion.com/ej2/21.1.35/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <script src="https://cdn.jsdelivr.net/npm/marked/marked.min.js"></script>
        <div id="defaultRTE">
In Rich Text Editor , you click the toolbar buttons to format the words and the changes are visible immediately. 
Markdown is not like that. When you format the word in Markdown format, you need to add Markdown syntax to the word to indicate which words 
and phrases should look different from each other

Rich Text Editor supports markdown editing when the editorMode set as **markdown** and using both *keyboard interaction* and *toolbar action*, you can apply the formatting to text.

We can add our own custom formation syntax for the Markdown formation, [sample link](https://ej2.syncfusion.com/home/).

The third-party library <b>Marked</b> is used in this sample to convert markdown into HTML content            
        </div>
    </div>
    <style>
        .e-richtexteditor textarea.e-content {
            float: left;
            border-right: 1px solid rgba(0, 0, 0, 0.12);
        }
        .e-richtexteditor .e-rte-content .e-content{
            min-height: 150px;
        }
    
        .e-richtexteditor .e-rte-content {
            overflow: hidden;
        }
    
        .e-icon-btn.e-active .e-md-preview::before {
            content: '\e350';
        }
    
        .e-icon-btn .e-md-preview::before {
            content: '\e345';
        }
    
        .e-rte-content .e-content {
            float: right;
            width: 50%;
            overflow: auto;
            height: inherit;
            padding: 8px;
            height: 100%;
        }
    
        .e-rte-content .e-content.e-pre-source {
            width: 100%;
        }
    
        .highcontrast .e-richtexteditor textarea.e-content {
            border-right: 1px solid #fff;
        }
    
        .sb-header {
            z-index: 100;
        }
    </style>


<script>
var ele = document.getElementById('container');
if(ele) {
    ele.style.visibility = "visible";
 }   
        </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Table

Rich Text Editor allows to insert Markdown table in edit panel with 2 X 2 rows and columns along with the heading. To use table tool, add the CreateTable item in toolbar items.

Insert table

To insert the table in Rich Text Editor, click the table toolbar option to insert the table into Rich Text Editor content and this is the default way in all the devices. Please refer the below sample and code snippets to add the table in Markdown editor

Source
Preview
index.js
index.html
Copied to clipboard
/**
 * Rich Text Editor Markdown Preview Sample
 */
ej.base.enableRipple(true);

var textArea;
var mdsource;
var mdSplit;
var htmlPreview;

var defaultRTE = new ej.richtexteditor.RichTextEditor({
    height: 340, editorMode: 'Markdown',
    toolbarSettings: {
        items: ['Bold', 'Italic', 'StrikeThrough', '|', 'Formats', 'OrderedList', 'UnorderedList', '|', 'CreateLink', 'Image', 'CreateTable', '|',
            { tooltipText: 'Preview', template: '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn">' +
                    '<span class="e-btn-icon e-md-preview e-icons"></span></button>' }, '|', 'Undo', 'Redo']
    },
    created: function () {
        textArea = defaultRTE.contentModule.getEditPanel();
        textArea.addEventListener('keyup', function (e) { markDownConversion(); });
        var rteObj = defaultRTE;
        mdsource = document.getElementById('preview-code');
        mdsource.addEventListener('click', function (e) {
            fullPreview({ mode: true, type: 'preview' });
            if (e.currentTarget.classList.contains('e-active')) {
                defaultRTE.disableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
                    'Formats', 'OrderedList', 'UnorderedList', '|',
                    'CreateLink', 'Image', 'Undo', 'Redo', 'CreateTable']);
            }
            else {
                defaultRTE.enableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
                    'Formats', 'OrderedList', 'UnorderedList', '|',
                    'CreateLink', 'Image', 'Undo', 'Redo', 'CreateTable']);
            }
        });
    },
});
defaultRTE.appendTo('#defaultRTE');

function markDownConversion() {
    if (mdsource.classList.contains('e-active')) {
        var id = defaultRTE.getID() + 'html-preview';
        var htmlPreview_1 = defaultRTE.element.querySelector('#' + id);
        var rteElement = defaultRTE.contentModule.getEditPanel();
        var rteValue = rteElement.value;
        htmlPreview.innerHTML = marked(defaultRTE.contentModule.getEditPanel().value);
    }
}

function fullPreview(e) {
    var id = defaultRTE.getID() + 'html-preview';
    htmlPreview = defaultRTE.element.querySelector('#' + id);
    if (mdsource.classList.contains('e-active')) {
        mdsource.classList.remove('e-active');
        mdsource.parentElement.title = 'Preview';
        textArea.style.display = 'block';
        textArea.style.width = '100%';
        htmlPreview.style.display = 'none';
    }
    else {
        mdsource.classList.add('e-active');
        if (!htmlPreview) {
            htmlPreview = ej.base.createElement('div', { className: 'e-content' });
            htmlPreview.id = id;
            textArea.parentNode.appendChild(htmlPreview);
        }
        if (e.type === 'preview') {
            textArea.style.display = 'none';
            htmlPreview.classList.add('e-pre-source');
        }
        else {
            htmlPreview.classList.remove('e-pre-source');
            textArea.style.width = '50%';
        }
        htmlPreview.style.display = 'block';
        markDownConversion();
        mdsource.parentElement.title = 'Code View';
    }
}
Copied to clipboard
<!DOCTYPE html><html lang="en"><head>
            
    <title>Essential JS 2 Rich Text Editor</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-base/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-richtexteditor/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-lists/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-navigations/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-popups/styles/material.css" rel="stylesheet">
     <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    
    
   
<script src="https://cdn.syncfusion.com/ej2/21.1.35/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <script src="https://cdn.jsdelivr.net/npm/marked/marked.min.js"></script>
        <div id="defaultRTE">
In Rich Text Editor , you click the toolbar buttons to format the words and the changes are visible immediately. 
Markdown is not like that. When you format the word in Markdown format, you need to add Markdown syntax to the word to indicate which words 
and phrases should look different from each other

Rich Text Editor supports markdown editing when the editorMode set as **markdown** and using both *keyboard interaction* and *toolbar action*, you can apply the formatting to text.

We can add our own custom formation syntax for the Markdown formation, [sample link](https://ej2.syncfusion.com/home/).

The third-party library <b>Marked</b> is used in this sample to convert markdown into HTML content            
        </div>
    </div>
    <style>
        .e-richtexteditor textarea.e-content {
            float: left;
            border-right: 1px solid rgba(0, 0, 0, 0.12);
        }
        .e-richtexteditor .e-rte-content .e-content{
            min-height: 150px;
        }
    
        .e-richtexteditor .e-rte-content {
            overflow: hidden;
        }
    
        .e-icon-btn.e-active .e-md-preview::before {
            content: '\e350';
        }
    
        .e-icon-btn .e-md-preview::before {
            content: '\e345';
        }
    
        .e-rte-content .e-content {
            float: right;
            width: 50%;
            overflow: auto;
            height: inherit;
            padding: 8px;
            height: 100%;
        }
    
        .e-rte-content .e-content.e-pre-source {
            width: 100%;
        }
    
        .highcontrast .e-richtexteditor textarea.e-content {
            border-right: 1px solid #fff;
        }
    
        .sb-header {
            z-index: 100;
        }
    </style>


<script>
var ele = document.getElementById('container');
if(ele) {
    ele.style.visibility = "visible";
 }   
        </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Changing table constants

The Markdown table constants can be changed for the table heading and the column name.

Source
Preview
index.js
index.html
Copied to clipboard
ej.base.enableRipple(true);
ej.base.L10n.load({
    'en-US': {
        'richtexteditor': {
            'TableHeadingText': 'Header',
            'TableColText': 'Cell'
        }
    }
});

var textArea;
var mdsource;
var mdSplit;
var htmlPreview;

var defaultRTE = new ej.richtexteditor.RichTextEditor({
    height: 340, editorMode: 'Markdown',
    toolbarSettings: {
        items: ['Bold', 'Italic', 'StrikeThrough', '|', 'Formats', 'OrderedList', 'UnorderedList', '|', 'CreateLink', 'Image', 'CreateTable', '|',
            { tooltipText: 'Preview', template: '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn">' +
                    '<span class="e-btn-icon e-md-preview e-icons"></span></button>' }, '|', 'Undo', 'Redo']
    },
    created: function () {
        textArea = defaultRTE.contentModule.getEditPanel();
        textArea.addEventListener('keyup', function (e) { markDownConversion(); });
        var rteObj = defaultRTE;
        mdsource = document.getElementById('preview-code');
        mdsource.addEventListener('click', function (e) {
            fullPreview({ mode: true, type: 'preview' });
            if (e.currentTarget.classList.contains('e-active')) {
                defaultRTE.disableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
                    'Formats', 'OrderedList', 'UnorderedList', '|',
                    'CreateLink', 'Image', 'Undo', 'Redo', 'CreateTable']);
            }
            else {
                defaultRTE.enableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
                    'Formats', 'OrderedList', 'UnorderedList', '|',
                    'CreateLink', 'Image', 'Undo', 'Redo', 'CreateTable']);
            }
        });
    },
});
defaultRTE.appendTo('#defaultRTE');

function markDownConversion() {
    if (mdsource.classList.contains('e-active')) {
        var id = defaultRTE.getID() + 'html-preview';
        var htmlPreview_1 = defaultRTE.element.querySelector('#' + id);
        var rteElement = defaultRTE.contentModule.getEditPanel();
        var rteValue = rteElement.value;
        htmlPreview.innerHTML = marked(defaultRTE.contentModule.getEditPanel().value);
    }
}

function fullPreview(e) {
    var id = defaultRTE.getID() + 'html-preview';
    htmlPreview = defaultRTE.element.querySelector('#' + id);
    if (mdsource.classList.contains('e-active')) {
        mdsource.classList.remove('e-active');
        mdsource.parentElement.title = 'Preview';
        textArea.style.display = 'block';
        textArea.style.width = '100%';
        htmlPreview.style.display = 'none';
    }
    else {
        mdsource.classList.add('e-active');
        if (!htmlPreview) {
            htmlPreview = ej.base.createElement('div', { className: 'e-content' });
            htmlPreview.id = id;
            textArea.parentNode.appendChild(htmlPreview);
        }
        if (e.type === 'preview') {
            textArea.style.display = 'none';
            htmlPreview.classList.add('e-pre-source');
        }
        else {
            htmlPreview.classList.remove('e-pre-source');
            textArea.style.width = '50%';
        }
        htmlPreview.style.display = 'block';
        markDownConversion();
        mdsource.parentElement.title = 'Code View';
    }
}
Copied to clipboard
<!DOCTYPE html><html lang="en"><head>
            
    <title>Essential JS 2 Rich Text Editor</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-base/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-richtexteditor/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-lists/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-navigations/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-popups/styles/material.css" rel="stylesheet">
     <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    
    
   
<script src="https://cdn.syncfusion.com/ej2/21.1.35/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <script src="https://cdn.jsdelivr.net/npm/marked/marked.min.js"></script>
        <div id="defaultRTE">
In Rich Text Editor , you click the toolbar buttons to format the words and the changes are visible immediately. 
Markdown is not like that. When you format the word in Markdown format, you need to add Markdown syntax to the word to indicate which words 
and phrases should look different from each other

Rich Text Editor supports markdown editing when the editorMode set as **markdown** and using both *keyboard interaction* and *toolbar action*, you can apply the formatting to text.

We can add our own custom formation syntax for the Markdown formation, [sample link](https://ej2.syncfusion.com/home/).

The third-party library <b>Marked</b> is used in this sample to convert markdown into HTML content            
        </div>
    </div>
    <style>
        .e-richtexteditor textarea.e-content {
            float: left;
            border-right: 1px solid rgba(0, 0, 0, 0.12);
        }
        .e-richtexteditor .e-rte-content .e-content{
            min-height: 150px;
        }
    
        .e-richtexteditor .e-rte-content {
            overflow: hidden;
        }
    
        .e-icon-btn.e-active .e-md-preview::before {
            content: '\e350';
        }
    
        .e-icon-btn .e-md-preview::before {
            content: '\e345';
        }
    
        .e-rte-content .e-content {
            float: right;
            width: 50%;
            overflow: auto;
            height: inherit;
            padding: 8px;
            height: 100%;
        }
    
        .e-rte-content .e-content.e-pre-source {
            width: 100%;
        }
    
        .highcontrast .e-richtexteditor textarea.e-content {
            border-right: 1px solid #fff;
        }
    
        .sb-header {
            z-index: 100;
        }
    </style>


<script>
var ele = document.getElementById('container');
if(ele) {
    ele.style.visibility = "visible";
 }   
        </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Custom format

The Rich Text Editor allows you to customize the markdown syntax by overriding its default syntax. Configure the customized markdown syntax using the formatter property.

This sample demonstrates how to customize tags of markdown formatting.

For example, apply + to Unordered list, apply 1., 2., 3. to Ordered list, for bold, __, and for italic _.

Source
Preview
index.js
index.html
Copied to clipboard
// initialize Rich Text Editor component
var defaultRTE = new ej.richtexteditor.RichTextEditor({
    height: 340,
    toolbarSettings: {
        items: ['Bold', 'Italic', 'StrikeThrough', '|',
            'Formats', 'OrderedList', 'UnorderedList', '|',
            'CreateLink', 'Image', '|', 'Undo', 'Redo']
    },
    editorMode: 'Markdown',
    formatter: new ej.richtexteditor.MarkdownFormatter({
        listTags: { 'OL': '2. ', 'UL': '+ ' },
        formatTags: {
            'Blockquote': '> '
        },
        selectionTags: { 'Bold': '__', 'Italic': '_' }
    })
});
defaultRTE.appendTo('#defaultRTE');
Copied to clipboard
<!DOCTYPE html><html lang="en"><head>
            
    <title>Essential JS 2 Rich Text Editor</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-base/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-richtexteditor/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-lists/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-navigations/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-popups/styles/material.css" rel="stylesheet">
     <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.1.35/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    
    
   
<script src="https://cdn.syncfusion.com/ej2/21.1.35/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <script src="https://cdn.jsdelivr.net/npm/marked/marked.min.js"></script>
        <div id="defaultRTE">
In Rich Text Editor , you click the toolbar buttons to format the words and the changes are visible immediately. 
Markdown is not like that. When you format the word in Markdown format, you need to add Markdown syntax to the word to indicate which words 
and phrases should look different from each other

Rich Text Editor supports markdown editing when the editorMode set as **markdown** and using both *keyboard interaction* and *toolbar action*, you can apply the formatting to text.

We can add our own custom formation syntax for the Markdown formation, [sample link](https://ej2.syncfusion.com/home/).

The third-party library <b>Marked</b> is used in this sample to convert markdown into HTML content            
        </div>
    </div>
    <style>
        .e-richtexteditor textarea.e-content {
            float: left;
            border-right: 1px solid rgba(0, 0, 0, 0.12);
        }
        .e-richtexteditor .e-rte-content .e-content{
            min-height: 150px;
        }
    
        .e-richtexteditor .e-rte-content {
            overflow: hidden;
        }
    
        .e-icon-btn.e-active .e-md-preview::before {
            content: '\e350';
        }
    
        .e-icon-btn .e-md-preview::before {
            content: '\e345';
        }
    
        .e-rte-content .e-content {
            float: right;
            width: 50%;
            overflow: auto;
            height: inherit;
            padding: 8px;
            height: 100%;
        }
    
        .e-rte-content .e-content.e-pre-source {
            width: 100%;
        }
    
        .highcontrast .e-richtexteditor textarea.e-content {
            border-right: 1px solid #fff;
        }
    
        .sb-header {
            z-index: 100;
        }
    </style>


<script>
var ele = document.getElementById('container');
if(ele) {
    ele.style.visibility = "visible";
 }   
        </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

See Also

Markdown in Angular Rich text editor component

19 Sep 202224 minutes to read

When you format the word in Markdown format, you should add Markdown syntax to the word to indicate the words and phrases that looks different from each other.

Rich Text Editor supports markdown editing when the editorMode set as markdown and using both keyboard interaction and toolbar action, you can apply the formatting to text

To use quick Markdown editing feature, inject MarkdownEditorService in the provider section of AppModule.

Supported Commands

The Angular Markdown editor supports the following commands to format the markdown content:

Commands Syntax Description  
Bold Sample content for **bold text**. For bold, add ** or __ to front and back of the text. For order list, precede each line with a number.
Italic Sample content for *Italic text*. For Italic, add * or _ to front and back of the text.  
Bold and Italics Sample content for ***bold and Italic text***. For bold and Italics, add *** to the front and back of the text.  
Heading 1 # Heading 1 content For heading 1, add # to start of the line.  
Heading 2 ## Heading 2 content For heading 2, add ## to start of the line.  
Heading 3 ### Heading 3 content For heading 3, add ### to start of the line.  
Heading 4 #### Heading 4 content For heading 4, add #### to start of the line.  
Heading 5 ##### Heading 5 content For heading 5, add ##### to start of the line.  
Heading 6 ###### Heading 6 content For heading 6, add ###### to start of the line.  
Line Break First line <br>Second line For line break, press enter two times (or) add <br> in between the first and the second line.  
Blockquotes > Blockquotes text For blockquotes, add > to start of the line.  
Strike Through Sample content for ~~strike through text~~. For strike through, add ~~ to front and back of the text.  
Code (Single line) `Single line code` For single line code, add ` to front and back of the text.  
Code block (Multi Line) ```
Multi line code text
Multi line code text
```
For multiple line code, add ``` in the new line before and after the content.  
Subscript <sub>Subscript text</sub> For subscript, add <sub> to the front and </sub> to the back of the text.  
Superscript <sup>Superscript text</sup> For superscript, add <sup> to the front and </sup> to the back of the text.  
Ordered List 1. First
1. Second
For ordered list, preceding one or more lines of text with 1.  
Unordered List * First
* second
For unordered list, preceding one or more lines of text with *.  
Links Link text without title text
[ Link text ](URL)
Link text with title text
[ Link text ](URL , “title text”)
Create an inline link by wrapping link text in brackets [ ], and then wrapping the URL as first parameter and title as second parameter in the parentheses ().
Note: The title text is optional, if needed it can be given manually.
 
Table | Heading 1 | Heading 2 |
|---------|---------|
| Col A1 | Col A2 |
| Col B1 | Col B2 |
Create a table using the pipes and underscores as given in the syntax to create 2 x 2 table.  
Horizontal Line *** (three asterix in new line)
(or)
___ (three underscores in new line)
For horizontal line, add *** or ___ to the start of the new line.  
Image ![](URL path) Create an image by wrapping the image source in parentheses ().  
Image with alternate text ![ alternate text ](URL path) Create an image with alternate text by wrapping an alternative text in brackets [], and then link of the image source in parentheses ().
Note: When inserting the image using toolbar, the alternate text cannot be provided that needs to be given manually.
 
Escape tick marks supported Sample text content with **bold and **not bold** text can be in the same line.** In the syntax, the whole content is made as bold where the content not bold can be made as normal text by adding the bold syntax to the start and end of the respective text. Likewise you can do the same for various inline commands.  
Escape Character \(any syntax) Escape any markdown syntax by prefix \ to the syntax.
Example:
\**Bold text**
 
HTML Entities Copyright: © - &copy;
Trade mark: ™ - &trade;
Registered: ® - &reg;
Ampersand: & - &amp;
Less than: < - &lt;
Greater than: > - &gt;
For HTML entities, add & and ; to the front and back of the respective entities.  

The above listed commands alone are supported in Syncfusion Markdown editor. For other unsupported commands, you can achieve using the HTML tags in Markdown editor. The foot notes, definitions, math, and check list markdown syntax are also not supported.

Markdown to HTML

The Rich Text Editor allows you to preview markdown changes immediately using preview. In this sample, the third-party library Marked is used to convert markdown into HTML content.

This sample demonstrates how to preview markdown changes in Rich Text Editor. Type or edit the display text, and apply format to view the preview of markdown. The actionComplete event can be used to convert Markdown to HTML.

import { enableRipple } from '@syncfusion/ej2-base';
enableRipple(true);
/**
 * Rich Text Editor Markdown Preview demo
 */
import { Component, ViewChild } from '@angular/core';
import { addClass, removeClass, Browser } from '@syncfusion/ej2-base';
import { RichTextEditorComponent, ToolbarService, LinkService } from '@syncfusion/ej2-angular-richtexteditor';
import { ImageService, MarkdownEditorService } from '@syncfusion/ej2-angular-richtexteditor';
import { createElement, KeyboardEventArgs, isNullOrUndefined } from '@syncfusion/ej2-base';
import * as Marked from 'marked';
    @Component({
    selector: 'app-root',
    template: `<ejs-richtexteditor id='mdPreview' #mdPreview [toolbarSettings]='tools' [editorMode]='mode' (created)='onCreate()' (actionComplete)="actionComplete($event)">
        <ng-template #valueTemplate>
            In Rich Text Editor , you click the toolbar buttons to format the words and the changes are visible immediately.
            Markdown is not like that. When you format the word in Markdown format, you need to
            add Markdown syntax to the word to indicate which words
            and phrases should look different from each other.
            Rich Text Editor supports markdown editing when the editorMode set as **markdown** and using both *keyboard interaction* and *toolbar action*, you can apply the formatting to text.
            You can add our own custom formation syntax for the Markdown formation, [sample link](https://ej2.syncfusion.com/home/).
            The third-party library <b>Marked</b> is used in this sample to convert markdown into HTML content.
        </ng-template>
    </ejs-richtexteditor>`,
    providers: [ToolbarService, LinkService, ImageService, MarkdownEditorService]
    })
export class AppComponent  {
        @ViewChild('mdPreview')
public rteObj: RichTextEditorComponent;
public textArea: HTMLTextAreaElement;
public mdsource: HTMLElement;
public mdSplit: HTMLElement;
public htmlPreview: HTMLElement;
public tools: object = {
    items: ['Bold', 'Italic', 'StrikeThrough', '|', 'Formats', 'OrderedList', 'UnorderedList', '|', 'CreateLink', 'Image', '|',
        {
            tooltipText: 'Preview',
            template: '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn">' +
            '<span class="e-btn-icon e-md-preview e-icons"></span></button>'
        }, {
            tooltipText: 'Split Editor',
            template: '<button id="MD_Preview" class="e-tbar-btn e-control e-btn e-icon-btn">' +
            '<span class="e-btn-icon e-view-side e-icons"></span></button>'
        }, 'FullScreen', '|', 'Undo', 'Redo']
};
public mode: string = 'Markdown';
public onCreate(): void {
    let script = document.createElement('script');
    script.src = 'https://cdn.jsdelivr.net/npm/marked/marked.min.js';
    document.head.appendChild(script);
    this.textArea = this.rteObj.contentModule.getEditPanel() as HTMLTextAreaElement;
    this.textArea.addEventListener('keyup', (e: KeyboardEventArgs) => {
        this.markDownConversion();
    });
    this.mdsource = document.getElementById('preview-code');
    this.mdsource.addEventListener('click', (e: MouseEvent) => {
        this.fullPreview({ mode: true, type: 'preview' });
        if ((e.target as HTMLElement).parentElement.classList.contains('e-active')) {
            this.rteObj.disableToolbarItem(['Bold', 'Italic', 'StrikeThrough', 'OrderedList',
                'UnorderedList', 'CreateLink', 'Image']);
            (e.target as HTMLElement).parentElement.parentElement.nextElementSibling.classList.add('e-overlay');
        } else {
            this.rteObj.enableToolbarItem(['Bold', 'Italic', 'StrikeThrough', 'OrderedList',
                'UnorderedList', 'CreateLink', 'Image']);
            (e.target as HTMLElement).parentElement.parentElement.nextElementSibling.classList.remove('e-overlay');
        }
    });
    this.mdSplit = document.getElementById('MD_Preview');
    this.mdSplit.addEventListener('click', (e: MouseEvent) => {
        if (this.rteObj.element.classList.contains('e-rte-full-screen')) {
            this.fullPreview({ mode: true, type: '' });
        }
        this.mdsource.classList.remove('e-active');
        this.rteObj.showFullScreen();
    });
}
public actionComplete(e: any): void {
    if (e.targetItem === 'Maximize' && isNullOrUndefined(e.args)) {
        this.fullPreview({ mode: true, type: '' });
    } else if (!this.mdSplit.parentElement.classList.contains('e-overlay')) {
        if (e.targetItem === 'Minimize') {
            this.textArea.style.display = 'block';
            this.textArea.style.width = '100%';
            if (this.htmlPreview) { this.htmlPreview.style.display = 'none'; }
            this.mdSplit.classList.remove('e-active');
            this.mdsource.classList.remove('e-active');
        }
        this.markDownConversion();
    }
}
public markDownConversion(): void {
    if (this.mdSplit.classList.contains('e-active')) {
        let id: string = this.rteObj.getID() + 'html-preview';
        let htmlPreview: HTMLElement = this.rteObj.element.querySelector('#' + id) as HTMLElement;
        debugger
        htmlPreview.innerHTML =  marked((this.rteObj.contentModule.getEditPanel() as HTMLTextAreaElement).value);
    }
}
public fullPreview(e: { [key: string]: string | boolean }): void {
    let id: string = this.rteObj.getID() + 'html-preview';
    this.htmlPreview = this.rteObj.element.querySelector('#' + id) as HTMLElement;
    if ((this.mdsource.classList.contains('e-active') || this.mdSplit.classList.contains('e-active')) && e.mode) {
        this.mdsource.classList.remove('e-active');
        this.mdSplit.classList.remove('e-active');
        this.textArea.style.display = 'block';
        this.textArea.style.width = '100%';
        this.htmlPreview.style.display = 'none';
    } else {
        this.mdsource.classList.add('e-active');
        this.mdSplit.classList.add('e-active');
        if (!this.htmlPreview) {
            this.htmlPreview = createElement('div', { className: 'e-content' });
            this.htmlPreview.id = id;
            this.textArea.parentNode.appendChild(this.htmlPreview);
        }
        if (e.type === 'preview') {
            this.textArea.style.display = 'none';
            this.htmlPreview.classList.add('e-pre-source');
        } else {
            this.htmlPreview.classList.remove('e-pre-source');
            this.textArea.style.width = '50%';
        }
        this.htmlPreview.style.display = 'block';
        this.htmlPreview.innerHTML = marked((this.rteObj.contentModule.getEditPanel() as HTMLTextAreaElement).value);
    }
}
}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { RichTextEditorAllModule } from '@syncfusion/ej2-angular-richtexteditor';
import { AppComponent } from './app.component';

/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule,
        RichTextEditorAllModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);

Table

Rich Text Editor allows to insert Markdown table in edit panel with 2 X 2 rows and columns along with the heading.
To use table tool, add the CreateTable item in toolbar items.

Insert table

To insert the table in Rich Text Editor’s content area, click the insert table icon in the toolbar option.
Please refer the below sample and code snippets to add the table in Markdown editor

import { enableRipple } from '@syncfusion/ej2-base';
enableRipple(true);
/**
 * Rich Text Editor Markdown demo with table
 */
import { Component, ViewChild } from '@angular/core';
import { RichTextEditorComponent, ToolbarService, LinkService } from '@syncfusion/ej2-angular-richtexteditor';
import { ImageService, MarkdownEditorService } from '@syncfusion/ej2-angular-richtexteditor';
import { createElement, KeyboardEventArgs, isNullOrUndefined } from '@syncfusion/ej2-base';
import * as Marked from 'marked';
@Component({
selector: 'app-root',
template: `<ejs-richtexteditor id='mdPreview' #mdPreview [toolbarSettings]='tools' [editorMode]='mode' (created)='onCreate()'
            (actionComplete)="actionComplete($event)">
            <ng-template #valueTemplate>
                In Rich Text Editor , you click the toolbar buttons to format the words and the changes are visible immediately.
                Markdown is not like that. When you format the word in Markdown format, you need to
                add Markdown syntax to the word to indicate which words
                and phrases should look different from each other.
                Rich Text Editor supports markdown editing when the editorMode set as **markdown** and using
                both *keyboard interaction* and *toolbar action*,you can apply the formatting to text.
                You can add our own custom formation syntax for the Markdown formation, [sample link](https://ej2.syncfusion.com/home/).
                The third-party library <b>Marked</b> is used in this sample to convert markdown into HTML content.
            </ng-template>
           </ejs-richtexteditor>`,
providers: [ToolbarService, LinkService, ImageService, MarkdownEditorService]
})
export class AppComponent  {
      @ViewChild('mdPreview')
public rteObj: RichTextEditorComponent;
public textArea: HTMLTextAreaElement;
public mdsource: HTMLElement;
public mdSplit: HTMLElement;
public htmlPreview: HTMLElement;
public tools: object = {
    items: ['Bold', 'Italic', 'StrikeThrough', '|', 'Formats', 'OrderedList',
            'UnorderedList', '|', 'CreateLink', 'Image', 'CreateTable', '|',
        {
            tooltipText: 'Preview',
            template: '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn">' +
            '<span class="e-btn-icon e-md-preview e-icons"></span></button>'
        }, {
            tooltipText: 'Split Editor',
            template: '<button id="MD_Preview" class="e-tbar-btn e-control e-btn e-icon-btn">' +
            '<span class="e-btn-icon e-view-side e-icons"></span></button>'
        }, 'FullScreen', '|', 'Undo', 'Redo']
};
public mode: string = 'Markdown';
public onCreate(): void {
    let script = document.createElement('script');
    script.src = 'https://cdn.jsdelivr.net/npm/marked/marked.min.js';
    document.head.appendChild(script);
    this.textArea = this.rteObj.contentModule.getEditPanel() as HTMLTextAreaElement;
    this.textArea.addEventListener('keyup', (e: KeyboardEventArgs) => {
        this.markDownConversion();
    });
    this.mdsource = document.getElementById('preview-code');
    this.mdsource.addEventListener('click', (e: MouseEvent) => {
        this.fullPreview({ mode: true, type: 'preview' });
        if ((e.target as HTMLElement).parentElement.classList.contains('e-active')) {
            this.rteObj.disableToolbarItem(['Bold', 'Italic', 'StrikeThrough', 'OrderedList',
                'UnorderedList', 'CreateLink', 'Image', 'CreateTable']);
            (e.target as HTMLElement).parentElement.parentElement.nextElementSibling.classList.add('e-overlay');
        } else {
            this.rteObj.enableToolbarItem(['Bold', 'Italic', 'StrikeThrough', 'OrderedList',
                'UnorderedList', 'CreateLink', 'Image', 'CreateTable']);
            (e.target as HTMLElement).parentElement.parentElement.nextElementSibling.classList.remove('e-overlay');
        }
    });
    this.mdSplit = document.getElementById('MD_Preview');
    this.mdSplit.addEventListener('click', (e: MouseEvent) => {
        if (this.rteObj.element.classList.contains('e-rte-full-screen')) {
            this.fullPreview({ mode: true, type: '' });
        }
        this.mdsource.classList.remove('e-active');
        this.rteObj.showFullScreen();
    });
}
public actionComplete(e: any): void {
    if (e.targetItem === 'Maximize' && isNullOrUndefined(e.args)) {
        this.fullPreview({ mode: true, type: '' });
    } else if (!this.mdSplit.parentElement.classList.contains('e-overlay')) {
        if (e.targetItem === 'Minimize') {
            this.textArea.style.display = 'block';
            this.textArea.style.width = '100%';
            if (this.htmlPreview) { this.htmlPreview.style.display = 'none'; }
            this.mdSplit.classList.remove('e-active');
            this.mdsource.classList.remove('e-active');
        }
        this.markDownConversion();
    }
}
public markDownConversion(): void {
    if (this.mdSplit.classList.contains('e-active')) {
        let id: string = this.rteObj.getID() + 'html-preview';
        let htmlPreview: HTMLElement = this.rteObj.element.querySelector('#' + id) as HTMLElement;
        htmlPreview.innerHTML = marked((this.rteObj.contentModule.getEditPanel() as HTMLTextAreaElement).value);
    }
}
public fullPreview(e: { [key: string]: string | boolean }): void {
    let id: string = this.rteObj.getID() + 'html-preview';
    this.htmlPreview = this.rteObj.element.querySelector('#' + id) as HTMLElement;
    if ((this.mdsource.classList.contains('e-active') || this.mdSplit.classList.contains('e-active')) && e.mode) {
        this.mdsource.classList.remove('e-active');
        this.mdSplit.classList.remove('e-active');
        this.textArea.style.display = 'block';
        this.textArea.style.width = '100%';
        this.htmlPreview.style.display = 'none';
    } else {
        this.mdsource.classList.add('e-active');
        this.mdSplit.classList.add('e-active');
        if (!this.htmlPreview) {
            this.htmlPreview = createElement('div', { className: 'e-content' });
            this.htmlPreview.id = id;
            this.textArea.parentNode.appendChild(this.htmlPreview);
        }
        if (e.type === 'preview') {
            this.textArea.style.display = 'none';
            this.htmlPreview.classList.add('e-pre-source');
        } else {
            this.htmlPreview.classList.remove('e-pre-source');
            this.textArea.style.width = '50%';
        }
        this.htmlPreview.style.display = 'block';
        this.htmlPreview.innerHTML = marked((this.rteObj.contentModule.getEditPanel() as HTMLTextAreaElement).value);
    }
}
}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { RichTextEditorAllModule } from '@syncfusion/ej2-angular-richtexteditor';
import { AppComponent } from './app.component';

/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule,
        RichTextEditorAllModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);

Changing table constants

The Markdown table constants can be changed for the table heading and the column names.

import { enableRipple } from '@syncfusion/ej2-base';
enableRipple(true);
/**
 * Rich Text Editor changing table constants (markdown)
 */
import { Component, ViewChild } from '@angular/core';
import { RichTextEditorComponent, ToolbarService, LinkService } from '@syncfusion/ej2-angular-richtexteditor';
import { ImageService, MarkdownEditorService } from '@syncfusion/ej2-angular-richtexteditor';
import { createElement, KeyboardEventArgs, isNullOrUndefined } from '@syncfusion/ej2-base';
import { L10n } from '@syncfusion/ej2-base';
import * as Marked from 'marked';

L10n.load({
'en-US': {
    'richtexteditor': {
        'TableHeadingText': 'Header',
        'TableColText': 'Cell'
      }
  }
});
@Component({
selector: 'app-root',
template: `<ejs-richtexteditor id='mdPreview' #mdPreview [toolbarSettings]='tools' [editorMode]='mode'
(created)='onCreate()' (actionComplete)="actionComplete($event)">
    <ng-template #valueTemplate>
        In Rich Text Editor , you click the toolbar buttons to format the words and the changes are visible immediately.
        Markdown is not like that. When you format the word in Markdown format, you need to
        add Markdown syntax to the word to indicate which words
        and phrases should look different from each other.
        Rich Text Editor supports markdown editing when the editorMode set as **markdown** and using
        both *keyboard interaction* and *toolbar action*, you can apply the formatting to text.
        You can add our own custom formation syntax for the Markdown formation, [sample link](https://ej2.syncfusion.com/home/).
        The third-party library <b>Marked</b> is used in this sample to convert markdown into HTML content.
    </ng-template>
</ejs-richtexteditor>`,
providers: [ToolbarService, LinkService, ImageService, MarkdownEditorService]
})
export class AppComponent  {
      @ViewChild('mdPreview')
public rteObj: RichTextEditorComponent;
public textArea: HTMLTextAreaElement;
public mdsource: HTMLElement;
public mdSplit: HTMLElement;
public htmlPreview: HTMLElement;
public tools: object = {
    items: ['Bold', 'Italic', 'StrikeThrough', '|', 'Formats', 'OrderedList', 'UnorderedList',
          '|', 'CreateLink', 'Image', 'CreateTable', '|',
        {
            tooltipText: 'Preview',
            template: '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn">' +
            '<span class="e-btn-icon e-md-preview e-icons"></span></button>'
        }, {
            tooltipText: 'Split Editor',
            template: '<button id="MD_Preview" class="e-tbar-btn e-control e-btn e-icon-btn">' +
            '<span class="e-btn-icon e-view-side e-icons"></span></button>'
        }, 'FullScreen', '|', 'Undo', 'Redo']
};
public mode: string = 'Markdown';
public onCreate(): void {
    let script = document.createElement('script');
    script.src = 'https://cdn.jsdelivr.net/npm/marked/marked.min.js';
    document.head.appendChild(script);
    this.textArea = this.rteObj.contentModule.getEditPanel() as HTMLTextAreaElement;
    this.textArea.addEventListener('keyup', (e: KeyboardEventArgs) => {
        this.markDownConversion();
    });
    this.mdsource = document.getElementById('preview-code');
    this.mdsource.addEventListener('click', (e: MouseEvent) => {
        this.fullPreview({ mode: true, type: 'preview' });
        if ((e.target as HTMLElement).parentElement.classList.contains('e-active')) {
            this.rteObj.disableToolbarItem(['Bold', 'Italic', 'StrikeThrough', 'OrderedList',
                'UnorderedList', 'CreateLink', 'Image', 'CreateTable']);
            (e.target as HTMLElement).parentElement.parentElement.nextElementSibling.classList.add('e-overlay');
        } else {
            this.rteObj.enableToolbarItem(['Bold', 'Italic', 'StrikeThrough', 'OrderedList',
                'UnorderedList', 'CreateLink', 'Image', 'CreateTable']);
            (e.target as HTMLElement).parentElement.parentElement.nextElementSibling.classList.remove('e-overlay');
        }
    });
    this.mdSplit = document.getElementById('MD_Preview');
    this.mdSplit.addEventListener('click', (e: MouseEvent) => {
        if (this.rteObj.element.classList.contains('e-rte-full-screen')) {
            this.fullPreview({ mode: true, type: '' });
        }
        this.mdsource.classList.remove('e-active');
        this.rteObj.showFullScreen();
    });
}
public actionComplete(e: any): void {
    if (e.targetItem === 'Maximize' && isNullOrUndefined(e.args)) {
        this.fullPreview({ mode: true, type: '' });
    } else if (!this.mdSplit.parentElement.classList.contains('e-overlay')) {
        if (e.targetItem === 'Minimize') {
            this.textArea.style.display = 'block';
            this.textArea.style.width = '100%';
            if (this.htmlPreview) { this.htmlPreview.style.display = 'none'; }
            this.mdSplit.classList.remove('e-active');
            this.mdsource.classList.remove('e-active');
        }
        this.markDownConversion();
    }
}
public markDownConversion(): void {
    if (this.mdSplit.classList.contains('e-active')) {
        let id: string = this.rteObj.getID() + 'html-preview';
        let htmlPreview: HTMLElement = this.rteObj.element.querySelector('#' + id) as HTMLElement;
        htmlPreview.innerHTML = marked((this.rteObj.contentModule.getEditPanel() as HTMLTextAreaElement).value);
    }
}
public fullPreview(e: { [key: string]: string | boolean }): void {
    let id: string = this.rteObj.getID() + 'html-preview';
    this.htmlPreview = this.rteObj.element.querySelector('#' + id) as HTMLElement;
    if ((this.mdsource.classList.contains('e-active') || this.mdSplit.classList.contains('e-active')) && e.mode) {
        this.mdsource.classList.remove('e-active');
        this.mdSplit.classList.remove('e-active');
        this.textArea.style.display = 'block';
        this.textArea.style.width = '100%';
        this.htmlPreview.style.display = 'none';
    } else {
        this.mdsource.classList.add('e-active');
        this.mdSplit.classList.add('e-active');
        if (!this.htmlPreview) {
            this.htmlPreview = createElement('div', { className: 'e-content' });
            this.htmlPreview.id = id;
            this.textArea.parentNode.appendChild(this.htmlPreview);
        }
        if (e.type === 'preview') {
            this.textArea.style.display = 'none';
            this.htmlPreview.classList.add('e-pre-source');
        } else {
            this.htmlPreview.classList.remove('e-pre-source');
            this.textArea.style.width = '50%';
        }
        this.htmlPreview.style.display = 'block';
        this.htmlPreview.innerHTML = marked((this.rteObj.contentModule.getEditPanel() as HTMLTextAreaElement).value);
    }
}
}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { RichTextEditorAllModule } from '@syncfusion/ej2-angular-richtexteditor';
import { AppComponent } from './app.component';

/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule,
        RichTextEditorAllModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);

Custom formation

The Rich Text Editor allows you to customize the markdown syntax by overriding its default syntax. Configure the customized markdown syntax using the formatterproperty.

This sample demonstrates how to customize tags of markdown formatting.

For example, apply ‘+’ to Unordered list, apply ‘1., 2., 3.’ to Ordered list, for bold, ‘_’, and for italic ‘’.

import { enableRipple } from '@syncfusion/ej2-base';
enableRipple(true);
/**
 * Rich Text Editor Markdown Preview Sample
 */
import { Component, ViewChild } from '@angular/core';
import { RichTextEditorComponent, MarkdownFormatter, ToolbarService } from '@syncfusion/ej2-angular-richtexteditor';
import { LinkService, ImageService, MarkdownEditorService } from '@syncfusion/ej2-angular-richtexteditor';
import { createElement, KeyboardEventArgs } from '@syncfusion/ej2-base';
import * as Marked from 'marked';
    @Component({
    selector: 'app-root',
    template: `<ejs-richtexteditor id='mdCustom' #mdCustom [toolbarSettings]='tools' [editorMode]='mode' [formatter]='formatter' (created)='onCreate()'>
        <ng-template #valueTemplate>
          The sample is configured with customized markdown syntax using the __formatter__ property.
          Type the content and click the toolbar item to view customized markdown syntax.
          For unordered list, you need to add a plus sign before the word (e.g., + list1).
          Or To make a phrase bold, you need to add two underscores before and after the phrase (e.g., __this text is bold__).
        </ng-template>
    </ejs-richtexteditor>`,
    providers: [ToolbarService, LinkService, ImageService, MarkdownEditorService]
    })
    export class AppComponent  {
    @ViewChild('mdCustom')
    public rteObj: RichTextEditorComponent;
    public textArea: HTMLTextAreaElement;
    public mdsource: HTMLElement;
    public tools: object = {
        items:  ['Bold', 'Italic', 'StrikeThrough', '|',
        'Formats', 'OrderedList', 'UnorderedList', '|',
        'CreateLink', 'Image', '|',
        {
            tooltipText: 'Preview',
            template: '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn">' +
                '<span class="e-btn-icon e-icons e-md-preview"></span></button>'
        }, 'Undo', 'Redo']
    };
    public mode: string = 'Markdown';
     public formatter: MarkdownFormatter = new MarkdownFormatter({
        listTags: { 'OL': '1., 2., 3.', 'UL': '+ ' },
        formatTags: {
            'Blockquote': '> '
        },
        selectionTags: {'Bold': '__',  'Italic': '_'}

    });
    public onCreate(): void {
        this.textArea = this.rteObj.contentModule.getEditPanel() as HTMLTextAreaElement;
        this.textArea.addEventListener('keyup', (e: KeyboardEventArgs) => {
            this.markDownConversion();
        });
        this.mdsource = document.getElementById('preview-code');
        this.mdsource.addEventListener('click', (e: MouseEvent) => {
            this.fullPreview();
        });
    }
    public markDownConversion(): void {
        if (this.mdsource.classList.contains('e-active')) {
            let id: string = this.rteObj.getID() + 'html-view';
            let htmlPreview: Element = this.rteObj.element.querySelector('#' + id);
            htmlPreview.innerHTML = marked((this.rteObj.contentModule.getEditPanel() as HTMLTextAreaElement).value);
        }
    }
    public fullPreview(): void {
        let id: string = this.rteObj.getID() + 'html-preview';
        let htmlPreview: HTMLElement = this.rteObj.element.querySelector('#' + id) as HTMLElement;
        if (this.mdsource.classList.contains('e-active')) {
            this.mdsource.classList.remove('e-active');
            this.textArea.style.display = 'block';
            htmlPreview.style.display = 'none';
        } else {
            this.mdsource.classList.add('e-active');
            if (!htmlPreview) {
                htmlPreview = createElement('div', { className: 'e-content e-pre-source' });
                htmlPreview.id = id;
                this.textArea.parentNode.appendChild(htmlPreview);
            }
            this.textArea.style.display = 'none';
            htmlPreview.style.display = 'block';
            htmlPreview.innerHTML = marked((this.rteObj.contentModule.getEditPanel() as HTMLTextAreaElement).value);
            this.mdsource.parentElement.title = 'Code View';
        }
    }
    }
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { RichTextEditorAllModule } from '@syncfusion/ej2-angular-richtexteditor';
import { AppComponent } from './app.component';

/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule,
        RichTextEditorAllModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);

Markdown in Vue Rich text editor component

17 Mar 202324 minutes to read

When you format the word in Markdown format, you should add Markdown syntax to the word to indicate the words and phrases that looks different from each other.

Rich Text Editor supports markdown editing when the editorMode set as markdown and using both keyboard interaction and toolbar action, you can apply the formatting to text

To use quick Markdown editing feature, inject MarkdownEditorService in the provider section of AppModule.

Supported Commands

The Vue Markdown editor supports the following commands to format the markdown content:

Commands Syntax Description  
Bold Sample content for **bold text**. For bold, add ** or __ to front and back of the text. For order list, precede each line with a number.
Italic Sample content for *Italic text*. For Italic, add * or _ to front and back of the text.  
Bold and Italics Sample content for ***bold and Italic text***. For bold and Italics, add *** to the front and back of the text.  
Heading 1 # Heading 1 content For heading 1, add # to start of the line.  
Heading 2 ## Heading 2 content For heading 2, add ## to start of the line.  
Heading 3 ### Heading 3 content For heading 3, add ### to start of the line.  
Heading 4 #### Heading 4 content For heading 4, add #### to start of the line.  
Heading 5 ##### Heading 5 content For heading 5, add ##### to start of the line.  
Heading 6 ###### Heading 6 content For heading 6, add ###### to start of the line.  
Line Break First line <br>Second line For line break, press enter two times (or) add <br> in between the first and the second line.  
Blockquotes > Blockquotes text For blockquotes, add > to start of the line.  
Strike Through Sample content for ~~strike through text~~. For strike through, add ~~ to front and back of the text.  
Code (Single line) `Single line code` For single line code, add ` to front and back of the text.  
Code block (Multi Line) ```
Multi line code text
Multi line code text
```
For multiple line code, add ``` in the new line before and after the content.  
Subscript <sub>Subscript text</sub> For subscript, add <sub> to the front and </sub> to the back of the text.  
Superscript <sup>Superscript text</sup> For superscript, add <sup> to the front and </sup> to the back of the text.  
Ordered List 1. First
1. Second
For ordered list, preceding one or more lines of text with 1.  
Unordered List * First
* second
For unordered list, preceding one or more lines of text with *.  
Links Link text without title text
[ Link text ](URL)
Link text with title text
[ Link text ](URL , “title text”)
Create an inline link by wrapping link text in brackets [ ], and then wrapping the URL as first parameter and title as second parameter in the parentheses ().
Note: The title text is optional, if needed it can be given manually.
 
Table | Heading 1 | Heading 2 |
|---------|---------|
| Col A1 | Col A2 |
| Col B1 | Col B2 |
Create a table using the pipes and underscores as given in the syntax to create 2 x 2 table.  
Horizontal Line *** (three asterix in new line)
(or)
___ (three underscores in new line)
For horizontal line, add *** or ___ to the start of the new line.  
Image ![](URL path) Create an image by wrapping the image source in parentheses ().  
Image with alternate text ![ alternate text ](URL path) Create an image with alternate text by wrapping an alternative text in brackets [], and then link of the image source in parentheses ().
Note: When inserting the image using toolbar, the alternate text cannot be provided that needs to be given manually.
 
Escape tick marks supported Sample text content with **bold and **not bold** text can be in the same line.** In the syntax, the whole content is made as bold where the content not bold can be made as normal text by adding the bold syntax to the start and end of the respective text. Likewise you can do the same for various inline commands.  
Escape Character \(any syntax) Escape any markdown syntax by prefix \ to the syntax.
Example:
\**Bold text**
 
HTML Entities Copyright: © - &copy;
Trade mark: ™ - &trade;
Registered: ® - &reg;
Ampersand: & - &amp;
Less than: < - &lt;
Greater than: > - &gt;
For HTML entities, add & and ; to the front and back of the respective entities.  

The above listed commands alone are supported in Syncfusion Markdown editor. For other unsupported commands, you can achieve using the HTML tags in Markdown editor. The foot notes, definitions, math, and check list markdown syntax are also not supported.

Markdown to HTML

The Rich Text Editor allows you to preview markdown changes immediately using preview. In this sample, the third-party library Marked is used to convert markdown into HTML content.

This sample demonstrates how to preview markdown changes in Rich Text Editor. Type or edit the display text, and apply format to view the preview of markdown. The actionComplete event can be used to convert Markdown to HTML.

<template>
  <div id="defaultRTE">
    <ejs-richtexteditor id="preview" ref="rteInstance" :toolbarSettings="toolbarSettings" :created="created" :actionComplete='actionComplete' :editorMode="editorMode" :height="height">
In Rich Text Editor , you click the toolbar buttons to format the words and the changes
are visible immediately.
Markdown is not like that. When you format the word in Markdown format, you need to
add Markdown syntax to the word to indicate which words
and phrases should look different from each other
Rich Text Editor supports markdown editing when the editorMode set as **markdown** and using both *keyboard interaction* and *toolbar action*, you can apply the formatting to text.
We can add our own custom formation syntax for the Markdown formation, [sample link](https://ej2.syncfusion.com/home/).
The third-party library <b>Marked</b> is used in this sample to convert markdown into HTML content.
      </ejs-richtexteditor>
  </div>
</template>
    <style>
    .e-richtexteditor .e-rte-content .e-content{
        min-height: 150px;
    }
    .e-richtexteditor .e-rte-content textarea.e-content {
        float: left;
        border-right: 1px solid rgba(0, 0, 0, 0.12);
    }
    .e-richtexteditor .e-rte-content {
        overflow: hidden;
    }
    .e-md-preview::before {
        content: '\e345';
    }

    .e-rte-content .e-content.e-pre-source {
        width: 100%;
    }
    .e-icon-btn.e-active .e-md-preview.e-icons::before {
        content: '\e350';
    }
</style>
<script>
import Vue from "vue";
import { Browser, addClass, removeClass, isNullOrUndefined } from "@syncfusion/ej2-base";
import { RichTextEditorPlugin, Toolbar, Link, Image, MarkdownEditor } from "@syncfusion/ej2-vue-richtexteditor";
import { createElement, KeyboardEventArgs } from '@syncfusion/ej2-vue-base';

Vue.use(RichTextEditorPlugin);

export default {
    data: function() {
        return {
            textArea: '',
            height: '300px',
        toolbarSettings: {
            items: ['Bold', 'Italic', 'StrikeThrough', '|', 'Formats', 'OrderedList', 'UnorderedList', '|', 'CreateLink', 'Image', '|',
                { tooltipText: 'Preview', template: '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn">' +
                    '<span class="e-btn-icon e-md-preview e-icons"></span></button>' },
                { tooltipText: 'Split Editor', template: '<button id="MD_Preview" class="e-tbar-btn e-control e-btn e-icon-btn">' +
                    '<span class="e-btn-icon e-view-side e-icons"></span></button>' }, 'FullScreen', '|', 'Undo', 'Redo']
        },
        editorMode: 'Markdown',
        };
    },
    methods: {
        created: function() {
            var script = document.createElement('script');
            script.src = 'https://cdn.jsdelivr.net/npm/marked/marked.min.js';
            document.head.appendChild(script);
            this.textArea = this.$refs.rteInstance.$el.parentNode.querySelector('.e-content');
            this.textArea.onkeyup = (Event) => {
                this.markDownConversion();
            };
            document.getElementById('preview-code').onclick = () => {
                this.fullPreview({ mode: true, type: 'preview'});
                 if (event.target.parentElement.classList.contains('e-active')) {
                    this.$refs.rteInstance.ej2Instances.disableToolbarItem(['Bold', 'Italic', 'StrikeThrough', 'Formats', 'OrderedList',
                     'UnorderedList', 'CreateLink', 'Image']);
                     event.target.parentElement.parentElement.nextElementSibling.classList.add('e-overlay');
                } else {
                    this.$refs.rteInstance.ej2Instances.enableToolbarItem(['Bold', 'Italic', 'StrikeThrough', 'Formats', 'OrderedList',
                     'UnorderedList', 'CreateLink', 'Image']);
                      event.target.parentElement.parentElement.nextElementSibling.classList.remove('e-overlay');
                }
            };
            document.getElementById('MD_Preview').onclick = () => {
                if (this.$refs.rteInstance.$el.classList.contains('e-rte-full-screen')) {
                    this.fullPreview({ mode: true, type: '' });
                }
                document.getElementById('preview-code').classList.remove('e-active');
                this.$refs.rteInstance.ej2Instances.showFullScreen();
            };
        },
        markDownConversion: function(){
        if (document.getElementById('MD_Preview').classList.contains('e-active')) {
            var id = this.$refs.rteInstance.ej2Instances.getID() + 'html-view';
            var htmlPreview = this.$refs.rteInstance.$el.parentNode.querySelector('#' + id);
            htmlPreview.innerHTML = marked(this.textArea.value);
        }
    },
    actionComplete: function(e) {
        var mdsource = document.getElementById('preview-code');
        var mdSplit = document.getElementById('MD_Preview');
        var id = this.$refs.rteInstance.ej2Instances.getID() + 'html-view';
        var htmlPreview = this.$refs.rteInstance.$el.parentNode.querySelector('#' + id);
            if (e.targetItem === 'Maximize' && isNullOrUndefined(e.args)) {
                this.fullPreview({ mode: true, type: '' });
            } else if (!mdSplit.parentElement.classList.contains('e-overlay')) {
                if (e.targetItem === 'Minimize') {
                this.textArea.style.display = 'block';
                this.textArea.style.width = '100%';
                if (htmlPreview) { htmlPreview.style.display = 'none'; }
                mdSplit.classList.remove('e-active');
                mdsource.classList.remove('e-active');
                }
            this.markDownConversion();
            }
        },
        fullPreview: function(event){
            var mdsource = document.getElementById('preview-code');
            var mdSplit = document.getElementById('MD_Preview');
            var id = this.$refs.rteInstance.ej2Instances.getID() + 'html-view';
            var htmlPreview = this.$refs.rteInstance.$el.parentNode.querySelector('#' + id);
        if ((mdsource.classList.contains('e-active') || mdSplit.classList.contains('e-active')) && event.mode) {
            mdsource.classList.remove('e-active');
            mdSplit.classList.remove('e-active');
            this.textArea.style.display = 'block';
            this.textArea.style.width = '100%';
            htmlPreview.style.display = 'none';
        } else {
            mdsource.classList.add('e-active');
             mdSplit.classList.add('e-active');
            if (!htmlPreview) {
                htmlPreview = document.createElement('div');
                htmlPreview.id = id;
                htmlPreview.setAttribute('class', 'e-content');
                this.textArea.parentNode.appendChild(htmlPreview);
            }
            if (event.type === 'preview') {
                this.textArea.style.display = 'none';
                htmlPreview.classList.add('e-pre-source');
            } else {
                htmlPreview.classList.remove('e-pre-source');
                this.textArea.style.width = '50%';
            }
            htmlPreview.style.display = 'block';
            htmlPreview.innerHTML = marked(this.$refs.rteInstance.ej2Instances.contentModule.getEditPanel().value);
            mdsource.parentElement.title = 'Code View';
        }
    }
    },
    provide:{
        richtexteditor:[Toolbar, Link, Image, MarkdownEditor]
    }
}
</script>
<style>
@import "../../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-inputs/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-lists/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-popups/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-buttons/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-navigations/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-splitbuttons/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-vue-richtexteditor/styles/material.css";
</style>

Table

Rich Text Editor allows to insert Markdown table in edit panel with 2 X 2 rows and columns along with the heading. To use table tool, add the CreateTable item in toolbar items.

Insert table

To insert the table in Rich Text Editor, click the table toolbar option to insert the table into Rich Text Editor content and this is the default way in all the devices.
Please refer the below sample and code snippets to add the table in Markdown editor

<template>
  <div id="defaultRTE">
    <ejs-richtexteditor id="preview" ref="rteInstance" :toolbarSettings="toolbarSettings" :created="created" :actionComplete='actionComplete' :editorMode="editorMode" :height="height">
In Rich Text Editor , you click the toolbar buttons to format the words and the changes
are visible immediately.
Markdown is not like that. When you format the word in Markdown format, you need to
add Markdown syntax to the word to indicate which words
and phrases should look different from each other
Rich Text Editor supports markdown editing when the editorMode set as **markdown** and using both *keyboard interaction* and *toolbar action*, you can apply the formatting to text.
We can add our own custom formation syntax for the Markdown formation, [sample link](https://ej2.syncfusion.com/home/).
The third-party library <b>Marked</b> is used in this sample to convert markdown into HTML content.
      </ejs-richtexteditor>
  </div>
</template>
    <style>
    .e-richtexteditor .e-rte-content .e-content{
        min-height: 150px;
    }
    .e-richtexteditor .e-rte-content textarea.e-content {
        float: left;
        border-right: 1px solid rgba(0, 0, 0, 0.12);
    }
    .e-richtexteditor .e-rte-content {
        overflow: hidden;
    }
    .e-md-preview::before {
        content: '\e345';
    }

    .e-rte-content .e-content.e-pre-source {
        width: 100%;
    }
    .e-icon-btn.e-active .e-md-preview.e-icons::before {
        content: '\e350';
    }
</style>
<script>
import Vue from "vue";
import { Browser, addClass, removeClass, isNullOrUndefined } from "@syncfusion/ej2-base";
import { RichTextEditorPlugin, Toolbar, Link, Image, MarkdownEditor } from "@syncfusion/ej2-vue-richtexteditor";
import { createElement, KeyboardEventArgs } from '@syncfusion/ej2-vue-base';

Vue.use(RichTextEditorPlugin);

export default {
    data: function() {
        return {
            textArea: '',
            height: '300px',
        toolbarSettings: {
            items: ['Bold', 'Italic', 'StrikeThrough', '|', 'Formats', 'OrderedList', 'UnorderedList', '|', 'CreateLink', 'Image', 'CreateTable', '|',
                { tooltipText: 'Preview', template: '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn">' +
                    '<span class="e-btn-icon e-md-preview e-icons"></span></button>' },
                { tooltipText: 'Split Editor', template: '<button id="MD_Preview" class="e-tbar-btn e-control e-btn e-icon-btn">' +
                    '<span class="e-btn-icon e-view-side e-icons"></span></button>' }, 'FullScreen', '|', 'Undo', 'Redo']
        },
        editorMode: 'Markdown',
        };
    },
    methods: {
        created: function() {
            var script = document.createElement('script');
            script.src = 'https://cdn.jsdelivr.net/npm/marked/marked.min.js';
            document.head.appendChild(script);
            this.textArea = this.$refs.rteInstance.$el.parentNode.querySelector('.e-content');
            this.textArea.onkeyup = (Event) => {
                this.markDownConversion();
            };
            document.getElementById('preview-code').onclick = () => {
                this.fullPreview({ mode: true, type: 'preview'});
                 if (event.target.parentElement.classList.contains('e-active')) {
                    this.$refs.rteInstance.ej2Instances.disableToolbarItem(['Bold', 'Italic', 'StrikeThrough', 'Formats', 'OrderedList',
                     'UnorderedList', 'CreateLink', 'Image', 'CreateTable']);
                     event.target.parentElement.parentElement.nextElementSibling.classList.add('e-overlay');
                } else {
                    this.$refs.rteInstance.ej2Instances.enableToolbarItem(['Bold', 'Italic', 'StrikeThrough', 'Formats', 'OrderedList',
                     'UnorderedList', 'CreateLink', 'Image', 'CreateTable']);
                      event.target.parentElement.parentElement.nextElementSibling.classList.remove('e-overlay');
                }
            };
            document.getElementById('MD_Preview').onclick = () => {
                if (this.$refs.rteInstance.$el.classList.contains('e-rte-full-screen')) {
                    this.fullPreview({ mode: true, type: '' });
                }
                document.getElementById('preview-code').classList.remove('e-active');
                this.$refs.rteInstance.ej2Instances.showFullScreen();
            };
        },
        markDownConversion: function(){
        if (document.getElementById('MD_Preview').classList.contains('e-active')) {
            var id = this.$refs.rteInstance.ej2Instances.getID() + 'html-view';
            var htmlPreview = this.$refs.rteInstance.$el.parentNode.querySelector('#' + id);
            htmlPreview.innerHTML = marked(this.textArea.value);
        }
    },
    actionComplete: function(e) {
        var mdsource = document.getElementById('preview-code');
        var mdSplit = document.getElementById('MD_Preview');
        var id = this.$refs.rteInstance.ej2Instances.getID() + 'html-view';
        var htmlPreview = this.$refs.rteInstance.$el.parentNode.querySelector('#' + id);
            if (e.targetItem === 'Maximize' && isNullOrUndefined(e.args)) {
                this.fullPreview({ mode: true, type: '' });
            } else if (!mdSplit.parentElement.classList.contains('e-overlay')) {
                if (e.targetItem === 'Minimize') {
                this.textArea.style.display = 'block';
                this.textArea.style.width = '100%';
                if (htmlPreview) { htmlPreview.style.display = 'none'; }
                mdSplit.classList.remove('e-active');
                mdsource.classList.remove('e-active');
                }
            this.markDownConversion();
            }
        },
        fullPreview: function(event){
            var mdsource = document.getElementById('preview-code');
             var mdSplit = document.getElementById('MD_Preview');
            var id = this.$refs.rteInstance.ej2Instances.getID() + 'html-view';
            var htmlPreview = this.$refs.rteInstance.$el.parentNode.querySelector('#' + id);
        if ((mdsource.classList.contains('e-active') || mdSplit.classList.contains('e-active')) && event.mode) {
            mdsource.classList.remove('e-active');
            mdSplit.classList.remove('e-active');
            this.textArea.style.display = 'block';
            this.textArea.style.width = '100%';
            htmlPreview.style.display = 'none';
        } else {
            mdsource.classList.add('e-active');
             mdSplit.classList.add('e-active');
            if (!htmlPreview) {
                htmlPreview = document.createElement('div');
                htmlPreview.id = id;
                htmlPreview.setAttribute('class', 'e-content');
                this.textArea.parentNode.appendChild(htmlPreview);
            }
            if (event.type === 'preview') {
                this.textArea.style.display = 'none';
                htmlPreview.classList.add('e-pre-source');
            } else {
                htmlPreview.classList.remove('e-pre-source');
                this.textArea.style.width = '50%';
            }
            htmlPreview.style.display = 'block';
            htmlPreview.innerHTML = marked(this.$refs.rteInstance.ej2Instances.contentModule.getEditPanel().value);
            mdsource.parentElement.title = 'Code View';
        }
    }
    },
    provide:{
        richtexteditor:[Toolbar, Link, Image, MarkdownEditor]
    }
}
</script>
<style>
@import "../../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-inputs/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-lists/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-popups/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-buttons/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-navigations/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-splitbuttons/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-vue-richtexteditor/styles/material.css";
</style>

Changing table constants

The Markdown table constants can be changed for the table heading and the column names.

<template>
  <div id="defaultRTE">
    <ejs-richtexteditor id="preview" ref="rteInstance" :toolbarSettings="toolbarSettings" :created="created" :actionComplete='actionComplete' :editorMode="editorMode" :height="height">
In Rich Text Editor , you click the toolbar buttons to format the words and the changes
are visible immediately.
Markdown is not like that. When you format the word in Markdown format, you need to
add Markdown syntax to the word to indicate which words
and phrases should look different from each other
Rich Text Editor supports markdown editing when the editorMode set as **markdown** and using both *keyboard interaction* and *toolbar action*, you can apply the formatting to text.
We can add our own custom formation syntax for the Markdown formation, [sample link](https://ej2.syncfusion.com/home/).
The third-party library <b>Marked</b> is used in this sample to convert markdown into HTML content.
      </ejs-richtexteditor>
  </div>
</template>
    <style>
    .e-richtexteditor .e-rte-content .e-content{
        min-height: 150px;
    }
    .e-richtexteditor .e-rte-content textarea.e-content {
        float: left;
        border-right: 1px solid rgba(0, 0, 0, 0.12);
    }
    .e-richtexteditor .e-rte-content {
        overflow: hidden;
    }
    .e-md-preview::before {
        content: '\e345';
    }

    .e-rte-content .e-content.e-pre-source {
        width: 100%;
    }
    .e-icon-btn.e-active .e-md-preview.e-icons::before {
        content: '\e350';
    }
</style>
<script>
import Vue from "vue";
import { Browser, addClass, removeClass, isNullOrUndefined } from "@syncfusion/ej2-base";
import { RichTextEditorPlugin, Toolbar, Link, Image, MarkdownEditor } from "@syncfusion/ej2-vue-richtexteditor";
import { createElement, KeyboardEventArgs } from '@syncfusion/ej2-vue-base';
import { L10n } from '@syncfusion/ej2-base';
L10n.load({
    'en-US': {
        'richtexteditor': {
            'TableHeadingText': 'Header',
            'TableColText': 'Cell'
         }
     }
});
Vue.use(RichTextEditorPlugin);

export default {
    data: function() {
        return {
            textArea: '',
            height: '300px',
        toolbarSettings: {
            items: ['Bold', 'Italic', 'StrikeThrough', '|', 'Formats', 'OrderedList', 'UnorderedList', '|', 'CreateLink', 'Image', 'CreateTable', '|',
                { tooltipText: 'Preview', template: '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn">' +
                    '<span class="e-btn-icon e-md-preview e-icons"></span></button>' },
                { tooltipText: 'Split Editor', template: '<button id="MD_Preview" class="e-tbar-btn e-control e-btn e-icon-btn">' +
                    '<span class="e-btn-icon e-view-side e-icons"></span></button>' }, 'FullScreen', '|', 'Undo', 'Redo']
        },
        editorMode: 'Markdown',
        };
    },
    methods: {
        created: function() {
            var script = document.createElement('script');
            script.src = 'https://cdn.jsdelivr.net/npm/marked/marked.min.js';
            document.head.appendChild(script);
            this.textArea = this.$refs.rteInstance.$el.parentNode.querySelector('.e-content');
            this.textArea.onkeyup = (Event) => {
                this.markDownConversion();
            };
            document.getElementById('preview-code').onclick = () => {
                this.fullPreview({ mode: true, type: 'preview'});
                 if (event.target.parentElement.classList.contains('e-active')) {
                    this.$refs.rteInstance.ej2Instances.disableToolbarItem(['Bold', 'Italic', 'StrikeThrough', 'Formats', 'OrderedList',
                     'UnorderedList', 'CreateLink', 'Image', 'CreateTable']);
                     event.target.parentElement.parentElement.nextElementSibling.classList.add('e-overlay');
                } else {
                    this.$refs.rteInstance.ej2Instances.enableToolbarItem(['Bold', 'Italic', 'StrikeThrough', 'Formats', 'OrderedList',
                     'UnorderedList', 'CreateLink', 'Image', 'CreateTable']);
                      event.target.parentElement.parentElement.nextElementSibling.classList.remove('e-overlay');
                }
            };
            document.getElementById('MD_Preview').onclick = () => {
                if (this.$refs.rteInstance.$el.classList.contains('e-rte-full-screen')) {
                    this.fullPreview({ mode: true, type: '' });
                }
                document.getElementById('preview-code').classList.remove('e-active');
                this.$refs.rteInstance.ej2Instances.showFullScreen();
            };
        },
        markDownConversion: function(){
        if (document.getElementById('MD_Preview').classList.contains('e-active')) {
            var id = this.$refs.rteInstance.ej2Instances.getID() + 'html-view';
            var htmlPreview = this.$refs.rteInstance.$el.parentNode.querySelector('#' + id);
            htmlPreview.innerHTML = marked(this.textArea.value);
        }
    },
    actionComplete: function(e) {
        var mdsource = document.getElementById('preview-code');
        var mdSplit = document.getElementById('MD_Preview');
        var id = this.$refs.rteInstance.ej2Instances.getID() + 'html-view';
        var htmlPreview = this.$refs.rteInstance.$el.parentNode.querySelector('#' + id);
            if (e.targetItem === 'Maximize' && isNullOrUndefined(e.args)) {
                this.fullPreview({ mode: true, type: '' });
            } else if (!mdSplit.parentElement.classList.contains('e-overlay')) {
                if (e.targetItem === 'Minimize') {
                this.textArea.style.display = 'block';
                this.textArea.style.width = '100%';
                if (htmlPreview) { htmlPreview.style.display = 'none'; }
                mdSplit.classList.remove('e-active');
                mdsource.classList.remove('e-active');
                }
            this.markDownConversion();
            }
        },
        fullPreview: function(event){
            var mdsource = document.getElementById('preview-code');
             var mdSplit = document.getElementById('MD_Preview');
            var id = this.$refs.rteInstance.ej2Instances.getID() + 'html-view';
            var htmlPreview = this.$refs.rteInstance.$el.parentNode.querySelector('#' + id);
        if ((mdsource.classList.contains('e-active') || mdSplit.classList.contains('e-active')) && event.mode) {
            mdsource.classList.remove('e-active');
            mdSplit.classList.remove('e-active');
            this.textArea.style.display = 'block';
            this.textArea.style.width = '100%';
            htmlPreview.style.display = 'none';
        } else {
            mdsource.classList.add('e-active');
             mdSplit.classList.add('e-active');
            if (!htmlPreview) {
                htmlPreview = document.createElement('div');
                htmlPreview.id = id;
                htmlPreview.setAttribute('class', 'e-content');
                this.textArea.parentNode.appendChild(htmlPreview);
            }
            if (event.type === 'preview') {
                this.textArea.style.display = 'none';
                htmlPreview.classList.add('e-pre-source');
            } else {
                htmlPreview.classList.remove('e-pre-source');
                this.textArea.style.width = '50%';
            }
            htmlPreview.style.display = 'block';
            htmlPreview.innerHTML = marked(this.$refs.rteInstance.ej2Instances.contentModule.getEditPanel().value);
            mdsource.parentElement.title = 'Code View';
        }
    }
    },
    provide:{
        richtexteditor:[Toolbar, Link, Image, MarkdownEditor]
    }
}
</script>
<style>
@import "https://ej2.syncfusion.com/vue/documentation/../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-inputs/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-lists/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-popups/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-buttons/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-navigations/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-splitbuttons/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-vue-richtexteditor/styles/material.css";
</style>

Custom formation

The Rich Text Editor allows you to customize the markdown syntax by overriding its default syntax. Configure the customized markdown syntax using the formatterproperty.

This sample demonstrates how to customize tags of markdown formatting.

For example, apply + to Unordered list, apply 1., 2., 3. to Ordered list, for bold, __, and for italic _.

<template>
  <ejs-richtexteditor ref="rteInstance" height="350" editorMode="Markdown" :value="value" :toolbarSettings="toolbarConfig" :created="created" :formatter="formatter">
  </ejs-richtexteditor>
</template>

<style>
  .e-richtexteditor .e-rte-content .e-content{
        min-height: 150px;
    }
    .e-richtexteditor .e-rte-content textarea.e-content {
        float: left;
        border-right: 1px solid rgba(0, 0, 0, 0.12);
    }
    .e-richtexteditor .e-rte-content {
        overflow: hidden;
    }
    .e-md-preview::before {
        content: '\e345';
    }

    .e-rte-content .e-content.e-pre-source {
        width: 100%;
    }
    .e-icon-btn.e-active .e-md-preview.e-icons::before {
        content: '\e350';
    } content: '\e350';
  }
</style>

<script>
  import Vue from 'vue';
  import { createElement, KeyboardEventArgs } from "@syncfusion/ej2-base";
  import { RichTextEditorPlugin, Toolbar, Link, Image, MarkdownEditor, MarkdownFormatter } from '@syncfusion/ej2-vue-richtexteditor';

  Vue.use(RichTextEditorPlugin);

  export default {
    data() {
      return {
        value: `***Overview***
  The Rich Text Editor component is WYSIWYG ("what you see is what you get") editor used to create and edit the content and return valid HTML markup or markdown (MD) of the content. The editor provides a standard toolbar to format content using its commands. Modular library features to load the necessary functionality on demand. The toolbar contains commands to align the text, insert link, insert image, insert list, undo/redo operation, HTML view, and more.

  ***Key features***
  - *Mode*: Provides IFRAME and DIV mode.
  - *Module*: Modular library to load the necessary functionality on demand.
  - *Toolbar*: Provide a fully customizable toolbar.
  - *Editing*: HTML view to edit the source directly for developers.
  - *Third-party Integration*: Supports to integrate third-party library.
  - *Preview*: Preview the modified content before saving it.
  - *Tools*: Handling images, hyperlinks, video, uploads and more.
  - *Undo and Redo*: Undo/redo manager.
  - *Lists*:Creates bulleted and numbered list.`,
        toolbarConfig: {
          items: [
            'Bold', 'Italic', 'StrikeThrough', '|',
            'Formats', 'OrderedList', 'UnorderedList', '|',
            'CreateLink', 'Image', '|',
            {
              tooltipText: 'Preview',
              template: '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn">' +
                '<span class="e-btn-icon e-md-preview e-icons"></span></button>'
            },
            '|', 'Undo', 'Redo'
          ]
        },
        formatter: new MarkdownFormatter({
            listTags: { 'OL': '1., 2., 3.', 'UL': '+ ' },
            formatTags: {
                'Blockquote': '> '
            },
            selectionTags: {'Bold': ' __ ',  'Italic': ' _ '}
        }),
      }
    },
    methods: {
      created: function() {
        var script = document.createElement('script');
        script.src = 'https://cdn.jsdelivr.net/npm/marked/marked.min.js';
        document.head.appendChild(script);
        this.textArea = this.$refs.rteInstance.$el.parentNode.querySelector('.e-content');
        this.textArea.onkeyup = (Event) => {
        this.markDownConversion();
        };
        document.getElementById('preview-code').onclick = () => {
          this.fullPreview({ mode: true, type: 'preview'});
          if (event.target.parentElement.classList.contains('e-active')) {
            this.$refs.rteInstance.ej2Instances.disableToolbarItem([
              'Bold', 'Italic', 'StrikeThrough', 'Formats', 'OrderedList',
              'UnorderedList', 'CreateLink', 'Image'
            ]);
            event.target.parentElement.parentElement.nextElementSibling.classList.add('e-overlay');
          } else {
            this.$refs.rteInstance.ej2Instances.enableToolbarItem([
              'Bold', 'Italic', 'StrikeThrough', 'Formats', 'OrderedList',
              'UnorderedList', 'CreateLink', 'Image'
            ]);
            event.target.parentElement.parentElement.nextElementSibling.classList.remove('e-overlay');
          }
        };
      },
      markDownConversion: function() {
        if (document.getElementById('MD_Preview').classList.contains('e-active')) {
          var id = this.$refs.rteInstance.ej2Instances.getID() + 'html-view';
          var htmlPreview = this.$refs.rteInstance.$el.querySelector('#' + id);
          htmlPreview.innerHTML = marked(this.textArea.value);
        }
      },
      fullPreview: function(event){
        var mdSource = document.getElementById('preview-code');
        var id = this.$refs.rteInstance.ej2Instances.getID() + 'html-view';
        var htmlPreview = this.$refs.rteInstance.$el.parentNode.querySelector('#' + id);
        if ((mdSource.classList.contains('e-active')) && event.mode) {
          mdSource.classList.remove('e-active');
          this.textArea.style.display = 'block';
          this.textArea.style.width = '100%';
          htmlPreview.style.display = 'none';
        } else {
          mdSource.classList.add('e-active');
          if (!htmlPreview) {
            htmlPreview = document.createElement('div');
            htmlPreview.id = id;
            htmlPreview.setAttribute('class', 'e-content');
            this.textArea.parentNode.appendChild(htmlPreview);
          }
          if (event.type === 'preview') {
            this.textArea.style.display = 'none';
            htmlPreview.classList.add('e-pre-source');
          } else {
            htmlPreview.classList.remove('e-pre-source');
            this.textArea.style.width = '50%';
          }
          htmlPreview.style.display = 'block';
          htmlPreview.innerHTML = marked(this.$refs.rteInstance.ej2Instances.contentModule.getEditPanel().value);
          mdSource.parentElement.title = 'Code View';
        }
      }
    },
    provide: {
      richtexteditor: [Toolbar, Link, Image, MarkdownEditor]
    }
  }
</script>

<style>
@import "../../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-inputs/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-lists/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-popups/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-buttons/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-navigations/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-splitbuttons/styles/material.css";
@import "../../node_modules/@syncfusion/ej2-vue-richtexteditor/styles/material.css";
</style>

See Also

Markdown in React Rich text editor component
20 Jan 202324 minutes to read
When you format the word in Markdown format, you should add Markdown syntax to the word to indicate the words and phrases that looks different from each other.
Rich Text Editor supports markdown editing when the editorMode set as markdown and using both keyboard interaction and toolbar action, you can apply the formatting to text.
To create Rich Text Editor with Markdown editing feature, inject the MarkdownEditor module to the RTE using the
RichTextEditor.Inject(MarkdownEditor)
method.
Supported Commands
The React Markdown editor supports the following commands to format the markdown content:
Commands | Syntax | Description | |
---|---|---|---|
Bold | Sample content for ** bold text** . |
For bold, add ** or __ to front and back of the text. |
For order list, precede each line with a number. |
Italic | Sample content for * Italic text* . |
For Italic, add * or _ to front and back of the text. |
|
Bold and Italics | Sample content for *** bold and Italic text*** . |
For bold and Italics, add *** to the front and back of the text. |
|
Heading 1 |
# Heading 1 content |
For heading 1, add # to start of the line. |
|
Heading 2 |
## Heading 2 content |
For heading 2, add ## to start of the line. |
|
Heading 3 |
### Heading 3 content |
For heading 3, add ### to start of the line. |
|
Heading 4 |
#### Heading 4 content |
For heading 4, add #### to start of the line. |
|
Heading 5 |
##### Heading 5 content |
For heading 5, add ##### to start of the line. |
|
Heading 6 |
###### Heading 6 content |
For heading 6, add ###### to start of the line. |
|
Line Break | First line <br> Second line |
For line break, press enter two times (or) add <br> in between the first and the second line. |
|
Blockquotes |
> Blockquotes text |
For blockquotes, add > to start of the line. |
|
Strike Through | Sample content for ~~ strike through text~~ . |
For strike through, add ~~ to front and back of the text. |
|
Code (Single line) | `Single line code` | For single line code, add ` to front and back of the text. | |
Code block (Multi Line) | ``` Multi line code text Multi line code text ``` |
For multiple line code, add ``` in the new line before and after the content. | |
Subscript |
<sub> Subscript text</sub>
|
For subscript, add <sub> to the front and </sub> to the back of the text. |
|
Superscript |
<sup> Superscript text</sup>
|
For superscript, add <sup> to the front and </sup> to the back of the text. |
|
Ordered List |
1. First1. Second |
For ordered list, preceding one or more lines of text with 1.
|
|
Unordered List |
* First* second |
For unordered list, preceding one or more lines of text with * . |
|
Links |
Link text without title text[ Link text ]( URL) Link text with title text [ Link text ]( URL , “title text”)
|
Create an inline link by wrapping link text in brackets [ ] , and then wrapping the URL as first parameter and title as second parameter in the parentheses () .Note: The title text is optional, if needed it can be given manually. |
|
Table |
| Heading 1 | Heading 2 | |---------|---------| | Col A1 | Col A2 | | Col B1 | Col B2 |
|
Create a table using the pipes and underscores as given in the syntax to create 2 x 2 table. | |
Horizontal Line |
*** (three asterix in new line)(or) ___ (three underscores in new line) |
For horizontal line, add *** or ___ to the start of the new line. |
|
Image |

|
Create an image by wrapping the image source in parentheses () . |
|
Image with alternate text |

|
Create an image with alternate text by wrapping an alternative text in brackets [] , and then link of the image source in parentheses () .Note: When inserting the image using toolbar, the alternate text cannot be provided that needs to be given manually. |
|
Escape tick marks supported | Sample text content with ** bold and ** not bold** text can be in the same line.**
|
In the syntax, the whole content is made as bold where the content not bold can be made as normal text by adding the bold syntax to the start and end of the respective text. Likewise you can do the same for various inline commands. |
|
Escape Character |
\( any syntax)
|
Escape any markdown syntax by prefix \ to the syntax.Example: \** Bold text**
|
|
HTML Entities | Copyright: © - © Trade mark: ™ - ™ Registered: ® - ® Ampersand: & - & Less than: < - < Greater than: > - >
|
For HTML entities, add & and ; to the front and back of the respective entities. |
The above listed commands alone are supported in Syncfusion Markdown editor. For other unsupported commands, you can achieve using the HTML tags in Markdown editor. The foot notes, definitions, math, and check list markdown syntax are also not supported.
Markdown to HTML
The Rich Text Editor allows you to preview markdown changes immediately using preview. In this sample, the third-party library Marked is used to convert markdown into HTML content.
This sample demonstrates how to preview markdown changes in Rich Text Editor. Type or edit the display text, and apply format to view the preview of markdown. The actionComplete event can be used to convert Markdown to HTML.
[Class-component]
/**
* Rich Text Editor - Markdown to HTML Sample
*/
import { isNullOrUndefined } from '@syncfusion/ej2-base';
import { createElement } from '@syncfusion/ej2-base';
import { Image, Link, MarkdownEditor, RichTextEditor, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
RichTextEditor.Inject(Image, Link, MarkdownEditor, Toolbar);
import * as React from 'react';
class App extends React.Component {
mdSource;
mdSplit;
htmlPreview;
defaultRTE;
textArea;
value = `***Overview***
The Rich Text Editor component is WYSIWYG ("what you see is what you get") editor used to create and edit the content and return valid HTML markup or markdown (MD) of the content. The editor provides a standard toolbar to format content using its commands. Modular library features to load the necessary functionality on demand. The toolbar contains commands to align the text, insert link, insert image, insert list, undo/redo operation, HTML view, and more.
***Key features***
- *Mode*: Provides IFRAME and DIV mode.
- *Module*: Modular library to load the necessary functionality on demand.
- *Toolbar*: Provide a fully customizable toolbar.
- *Editing*: HTML view to edit the source directly for developers.
- *Third-party Integration*: Supports to integrate third-party library.
- *Preview*: Preview the modified content before saving it.
- *Tools*: Handling images, hyperlinks, video, uploads and more.
- *Undo and Redo*: Undo/redo manager.
- *Lists*: Creates bulleted and numbered list.`;
componentDidMount() {
this.defaultRTE = new RichTextEditor({
actionComplete: (e) => {
if (e.targetItem === 'Maximize' && isNullOrUndefined(e.args)) {
this.fullPreview({ mode: true, type: '' });
}
else if (!this.mdSplit.parentElement.classList.contains('e-overlay')) {
if (e.targetItem === 'Minimize') {
this.textArea.style.display = 'block';
this.textArea.style.width = '100%';
if (this.htmlPreview) {
this.htmlPreview.style.display = 'none';
}
this.mdSplit.classList.remove('e-active');
this.mdSource.classList.remove('e-active');
}
this.markDownConversion();
}
setTimeout(() => {
this.defaultRTE.toolbarModule.refreshToolbarOverflow();
}, 400);
},
created: () => {
this.textArea = this.defaultRTE.contentModule.getEditPanel();
this.textArea.addEventListener('keyup', (e) => {
this.markDownConversion();
});
this.mdSource = document.getElementById('preview-code');
this.mdSource.addEventListener('click', (e) => {
this.fullPreview({ mode: true, type: 'preview' });
if (e.currentTarget.classList.contains('e-active')) {
this.defaultRTE.disableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'Undo', 'Redo']);
e.currentTarget.parentElement.previousElementSibling.classList.add('e-overlay');
}
else {
this.defaultRTE.enableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'Undo', 'Redo']);
e.currentTarget.parentElement.previousElementSibling.classList.remove('e-overlay');
}
});
this.mdSplit = document.getElementById('MD_Preview');
this.mdSplit.addEventListener('click', (e) => {
if (this.defaultRTE.element.classList.contains('e-rte-full-screen')) {
this.fullPreview({ mode: true, type: '' });
}
this.mdSource.classList.remove('e-active');
if (!this.defaultRTE.element.classList.contains('e-rte-full-screen')) {
this.defaultRTE.showFullScreen();
}
});
},
editorMode: 'Markdown',
height: '300px',
toolbarSettings: {
items: [
'Bold', 'Italic', 'StrikeThrough', '|', 'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', '|',
{
template: '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn">' +
'<span class="e-btn-icon e-md-preview e-preview e-icons"></span></button>',
tooltipText: 'Preview'
},
{
template: '<button id="MD_Preview" class="e-tbar-btn e-control e-btn e-icon-btn">' +
'<span class="e-btn-icon e-view-side e-icons"></span></button>',
tooltipText: 'Split Editor',
},
'FullScreen', '|', 'Undo', 'Redo'
]
},
valueTemplate: this.value,
});
this.defaultRTE.appendTo('#markdownPreview');
}
markDownConversion() {
if (this.mdSplit.classList.contains('e-active')) {
const id = this.defaultRTE.getID() + 'html-preview';
const htmlPreview = this.defaultRTE.element.querySelector('#' + id);
htmlPreview.innerHTML = marked((this.defaultRTE.contentModule.getEditPanel()).value);
}
}
fullPreview(e) {
const id = this.defaultRTE.getID() + 'html-preview';
this.htmlPreview = this.defaultRTE.element.querySelector('#' + id);
if ((this.mdSource.classList.contains('e-active') || this.mdSplit.classList.contains('e-active')) && e.mode) {
this.mdSource.classList.remove('e-active');
this.mdSplit.classList.remove('e-active');
this.mdSource.parentElement.title = 'Preview';
this.textArea.style.display = 'block';
this.textArea.style.width = '100%';
this.htmlPreview.style.display = 'none';
}
else {
this.mdSource.classList.add('e-active');
this.mdSplit.classList.add('e-active');
if (!this.htmlPreview) {
this.htmlPreview = createElement('div', { className: 'e-content' });
this.htmlPreview.id = id;
this.textArea.parentNode.appendChild(this.htmlPreview);
}
if (e.type === 'preview') {
this.textArea.style.display = 'none';
this.htmlPreview.classList.add('e-pre-source');
this.htmlPreview.style.width = '100%';
}
else {
this.htmlPreview.classList.remove('e-pre-source');
this.textArea.style.width = '50%';
this.htmlPreview.style.width = '50%';
}
this.htmlPreview.style.display = 'block';
this.htmlPreview.innerHTML = marked((this.defaultRTE.contentModule.getEditPanel()).value);
this.mdSource.parentElement.title = 'Code View';
}
}
render() {
return (<div id="rte-default" className='control-pane'>
<div className='control-section' id="rtePreview">
<div className="content-wrapper">
<div id="markdownPreview"/>
</div>
</div>
</div>);
}
}
export default App;
/**
* Rich Text Editor - Markdown to HTML Sample
*/
import { isNullOrUndefined } from '@syncfusion/ej2-base';
import { createElement, KeyboardEventArgs } from '@syncfusion/ej2-base';
import { Image, Link, MarkdownEditor, RichTextEditor, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
RichTextEditor.Inject(Image, Link, MarkdownEditor, Toolbar);
import * as React from 'react';
class App extends React.Component<{},{}> {
public mdSource: any;
public mdSplit: HTMLElement;
public htmlPreview: any;
public defaultRTE: RichTextEditor;
public textArea: HTMLTextAreaElement;
public value: string = `***Overview***
The Rich Text Editor component is WYSIWYG ("what you see is what you get") editor used to create and edit the content and return valid HTML markup or markdown (MD) of the content. The editor provides a standard toolbar to format content using its commands. Modular library features to load the necessary functionality on demand. The toolbar contains commands to align the text, insert link, insert image, insert list, undo/redo operation, HTML view, and more.
***Key features***
- *Mode*: Provides IFRAME and DIV mode.
- *Module*: Modular library to load the necessary functionality on demand.
- *Toolbar*: Provide a fully customizable toolbar.
- *Editing*: HTML view to edit the source directly for developers.
- *Third-party Integration*: Supports to integrate third-party library.
- *Preview*: Preview the modified content before saving it.
- *Tools*: Handling images, hyperlinks, video, uploads and more.
- *Undo and Redo*: Undo/redo manager.
- *Lists*: Creates bulleted and numbered list.`;
public componentDidMount(): void {
this.defaultRTE = new RichTextEditor({
actionComplete: (e: any) => {
if (e.targetItem === 'Maximize' && isNullOrUndefined(e.args)) {
this.fullPreview({ mode: true, type: '' });
} else if (!(this.mdSplit as any).parentElement.classList.contains('e-overlay')) {
if (e.targetItem === 'Minimize') {
this.textArea.style.display = 'block';
this.textArea.style.width = '100%';
if (this.htmlPreview) { this.htmlPreview.style.display = 'none'; }
this.mdSplit.classList.remove('e-active');
this.mdSource.classList.remove('e-active');
}
this.markDownConversion();
}
setTimeout(() => {
this.defaultRTE.toolbarModule.refreshToolbarOverflow();
}, 400);
},
created: () => {
this.textArea = (this.defaultRTE as any).contentModule.getEditPanel();
this.textArea.addEventListener('keyup', (e: KeyboardEventArgs) => {
this.markDownConversion();
});
this.mdSource = document.getElementById('preview-code') as any;
this.mdSource.addEventListener('click', (e: MouseEvent) => {
this.fullPreview({ mode: true, type: 'preview' });
if ((e.currentTarget as HTMLElement).classList.contains('e-active')) {
this.defaultRTE.disableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'Undo', 'Redo']);
(e.currentTarget as any).parentElement.previousElementSibling.classList.add('e-overlay');
} else {
this.defaultRTE.enableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'Undo', 'Redo']);
(e.currentTarget as any).parentElement.previousElementSibling.classList.remove('e-overlay');
}
});
this.mdSplit = document.getElementById('MD_Preview') as any;
this.mdSplit.addEventListener('click', (e: MouseEvent) => {
if (this.defaultRTE.element.classList.contains('e-rte-full-screen')) {
this.fullPreview({ mode: true, type: '' });
}
this.mdSource.classList.remove('e-active');
if (!this.defaultRTE.element.classList.contains('e-rte-full-screen')) {
this.defaultRTE.showFullScreen();
}
});
},
editorMode: 'Markdown',
height: '300px',
toolbarSettings: {
items: [
'Bold', 'Italic', 'StrikeThrough', '|', 'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', '|',
{
template: '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn">' +
'<span class="e-btn-icon e-md-preview e-preview e-icons"></span></button>',
tooltipText: 'Preview'
},
{
template: '<button id="MD_Preview" class="e-tbar-btn e-control e-btn e-icon-btn">' +
'<span class="e-btn-icon e-view-side e-icons"></span></button>',
tooltipText: 'Split Editor',
},
'FullScreen', '|', 'Undo', 'Redo']
},
valueTemplate: this.value,
});
this.defaultRTE.appendTo('#markdownPreview');
}
public markDownConversion(): void {
if (this.mdSplit.classList.contains('e-active')) {
const id: string = this.defaultRTE.getID() + 'html-preview';
const htmlPreview: any = this.defaultRTE.element.querySelector('#' + id);
htmlPreview.innerHTML = marked(((this as any).defaultRTE.contentModule.getEditPanel()).value);
}
}
public fullPreview(e: { [key: string]: string | boolean }): void {
const id: string = this.defaultRTE.getID() + 'html-preview';
this.htmlPreview = this.defaultRTE.element.querySelector('#' + id);
if ((this.mdSource.classList.contains('e-active') || this.mdSplit.classList.contains('e-active')) && e.mode) {
this.mdSource.classList.remove('e-active');
this.mdSplit.classList.remove('e-active');
this.mdSource.parentElement.title = 'Preview';
this.textArea.style.display = 'block';
this.textArea.style.width = '100%';
this.htmlPreview.style.display = 'none';
} else {
this.mdSource.classList.add('e-active');
this.mdSplit.classList.add('e-active');
if (!this.htmlPreview) {
this.htmlPreview = createElement('div', { className: 'e-content' });
this.htmlPreview.id = id;
(this.textArea as any).parentNode.appendChild(this.htmlPreview);
}
if (e.type === 'preview') {
this.textArea.style.display = 'none'; this.htmlPreview.classList.add('e-pre-source');
this.htmlPreview.style.width = '100%';
} else {
this.htmlPreview.classList.remove('e-pre-source');
this.textArea.style.width = '50%';
this.htmlPreview.style.width = '50%';
}
this.htmlPreview.style.display = 'block';
this.htmlPreview.innerHTML = marked(((this as any).defaultRTE.contentModule.getEditPanel()).value);
this.mdSource.parentElement.title = 'Code View';
}
}
public render() {
return (
<div id="rte-default" className='control-pane'>
<div className='control-section' id="rtePreview">
<div className="content-wrapper">
<div id="markdownPreview"/>
</div>
</div>
</div>
);
}
}
export default App;
[Functional-component]
/**
* Rich Text Editor - Markdown to HTML Sample
*/
import { isNullOrUndefined } from '@syncfusion/ej2-base';
import { createElement } from '@syncfusion/ej2-base';
import { Image, Link, MarkdownEditor, RichTextEditor, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
RichTextEditor.Inject(Image, Link, MarkdownEditor, Toolbar);
import * as React from 'react';
import { useEffect } from "react";
function App() {
useEffect(() => {
defaultRTE = new RichTextEditor({
actionComplete: (e) => {
if (e.targetItem === 'Maximize' && isNullOrUndefined(e.args)) {
fullPreview({ mode: true, type: '' });
}
else if (!mdSplit.parentElement.classList.contains('e-overlay')) {
if (e.targetItem === 'Minimize') {
textArea.style.display = 'block';
textArea.style.width = '100%';
if (htmlPreview) {
htmlPreview.style.display = 'none';
}
mdSplit.classList.remove('e-active');
mdSource.classList.remove('e-active');
}
markDownConversion();
}
setTimeout(() => {
defaultRTE.toolbarModule.refreshToolbarOverflow();
}, 400);
},
created: () => {
textArea = defaultRTE.contentModule.getEditPanel();
textArea.addEventListener('keyup', (e) => {
markDownConversion();
});
mdSource = document.getElementById('preview-code');
mdSource.addEventListener('click', (e) => {
fullPreview({ mode: true, type: 'preview' });
if (e.currentTarget.classList.contains('e-active')) {
defaultRTE.disableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'Undo', 'Redo']);
e.currentTarget.parentElement.previousElementSibling.classList.add('e-overlay');
}
else {
defaultRTE.enableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'Undo', 'Redo']);
e.currentTarget.parentElement.previousElementSibling.classList.remove('e-overlay');
}
});
mdSplit = document.getElementById('MD_Preview');
mdSplit.addEventListener('click', (e) => {
if (defaultRTE.element.classList.contains('e-rte-full-screen')) {
fullPreview({ mode: true, type: '' });
}
mdSource.classList.remove('e-active');
if (!defaultRTE.element.classList.contains('e-rte-full-screen')) {
defaultRTE.showFullScreen();
}
});
},
editorMode: 'Markdown',
height: '300px',
toolbarSettings: {
items: [
'Bold', 'Italic', 'StrikeThrough', '|', 'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', '|',
{
template: '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn">' +
'<span class="e-btn-icon e-md-preview e-preview e-icons"></span></button>',
tooltipText: 'Preview'
},
{
template: '<button id="MD_Preview" class="e-tbar-btn e-control e-btn e-icon-btn">' +
'<span class="e-btn-icon e-view-side e-icons"></span></button>',
tooltipText: 'Split Editor',
},
'FullScreen', '|', 'Undo', 'Redo'
]
},
valueTemplate: value,
});
defaultRTE.appendTo('#markdownPreview');
});
let mdSource;
let mdSplit;
let htmlPreview;
let defaultRTE;
let textArea;
let value = `***Overview***
The Rich Text Editor component is WYSIWYG ("what you see is what you get") editor used to create and edit the content and return valid HTML markup or markdown (MD) of the content. The editor provides a standard toolbar to format content using its commands. Modular library features to load the necessary functionality on demand. The toolbar contains commands to align the text, insert link, insert image, insert list, undo/redo operation, HTML view, and more.
***Key features***
- *Mode*: Provides IFRAME and DIV mode.
- *Module*: Modular library to load the necessary functionality on demand.
- *Toolbar*: Provide a fully customizable toolbar.
- *Editing*: HTML view to edit the source directly for developers.
- *Third-party Integration*: Supports to integrate third-party library.
- *Preview*: Preview the modified content before saving it.
- *Tools*: Handling images, hyperlinks, video, uploads and more.
- *Undo and Redo*: Undo/redo manager.
- *Lists*: Creates bulleted and numbered list.`;
function markDownConversion() {
if (mdSplit.classList.contains('e-active')) {
const id = defaultRTE.getID() + 'html-preview';
const htmlPreview = defaultRTE.element.querySelector('#' + id);
htmlPreview.innerHTML = marked((defaultRTE.contentModule.getEditPanel()).value);
}
}
function fullPreview(e) {
const id = defaultRTE.getID() + 'html-preview';
htmlPreview = defaultRTE.element.querySelector('#' + id);
if ((mdSource.classList.contains('e-active') || mdSplit.classList.contains('e-active')) && e.mode) {
mdSource.classList.remove('e-active');
mdSplit.classList.remove('e-active');
mdSource.parentElement.title = 'Preview';
textArea.style.display = 'block';
textArea.style.width = '100%';
htmlPreview.style.display = 'none';
}
else {
mdSource.classList.add('e-active');
mdSplit.classList.add('e-active');
if (!htmlPreview) {
htmlPreview = createElement('div', { className: 'e-content' });
htmlPreview.id = id;
textArea.parentNode.appendChild(htmlPreview);
}
if (e.type === 'preview') {
textArea.style.display = 'none';
htmlPreview.classList.add('e-pre-source');
htmlPreview.style.width = '100%';
}
else {
htmlPreview.classList.remove('e-pre-source');
textArea.style.width = '50%';
htmlPreview.style.width = '50%';
}
htmlPreview.style.display = 'block';
htmlPreview.innerHTML = marked((defaultRTE.contentModule.getEditPanel()).value);
mdSource.parentElement.title = 'Code View';
}
}
return (<div id="rte-default" className='control-pane'>
<div className='control-section' id="rtePreview">
<div className="content-wrapper">
<div id="markdownPreview"/>
</div>
</div>
</div>);
}
export default App;
/**
* Rich Text Editor - Markdown to HTML Sample
*/
import { isNullOrUndefined } from '@syncfusion/ej2-base';
import { createElement, KeyboardEventArgs } from '@syncfusion/ej2-base';
import { Image, Link, MarkdownEditor, RichTextEditor, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
RichTextEditor.Inject(Image, Link, MarkdownEditor, Toolbar);
import * as React from 'react';
import { useEffect } from "react";
function App() {
useEffect(() => {
defaultRTE = new RichTextEditor({
actionComplete: (e: any) => {
if (e.targetItem === 'Maximize' && isNullOrUndefined(e.args)) {
fullPreview({ mode: true, type: '' });
} else if (!(mdSplit as any).parentElement.classList.contains('e-overlay')) {
if (e.targetItem === 'Minimize') {
textArea.style.display = 'block';
textArea.style.width = '100%';
if (htmlPreview) { htmlPreview.style.display = 'none'; }
mdSplit.classList.remove('e-active');
mdSource.classList.remove('e-active');
}
markDownConversion();
}
setTimeout(() => {
defaultRTE.toolbarModule.refreshToolbarOverflow();
}, 400);
},
created: () => {
textArea = (defaultRTE as any).contentModule.getEditPanel();
textArea.addEventListener('keyup', (e: KeyboardEventArgs) => {
markDownConversion();
});
mdSource = document.getElementById('preview-code') as any;
mdSource.addEventListener('click', (e: MouseEvent) => {
fullPreview({ mode: true, type: 'preview' });
if ((e.currentTarget as HTMLElement).classList.contains('e-active')) {
defaultRTE.disableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'Undo', 'Redo']);
(e.currentTarget as any).parentElement.previousElementSibling.classList.add('e-overlay');
} else {
defaultRTE.enableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'Undo', 'Redo']);
(e.currentTarget as any).parentElement.previousElementSibling.classList.remove('e-overlay');
}
});
mdSplit = document.getElementById('MD_Preview') as any;
mdSplit.addEventListener('click', (e: MouseEvent) => {
if (defaultRTE.element.classList.contains('e-rte-full-screen')) {
fullPreview({ mode: true, type: '' });
}
mdSource.classList.remove('e-active');
if (!defaultRTE.element.classList.contains('e-rte-full-screen')) {
defaultRTE.showFullScreen();
}
});
},
editorMode: 'Markdown',
height: '300px',
toolbarSettings: {
items: [
'Bold', 'Italic', 'StrikeThrough', '|', 'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', '|',
{
template: '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn">' +
'<span class="e-btn-icon e-md-preview e-preview e-icons"></span></button>',
tooltipText: 'Preview'
},
{
template: '<button id="MD_Preview" class="e-tbar-btn e-control e-btn e-icon-btn">' +
'<span class="e-btn-icon e-view-side e-icons"></span></button>',
tooltipText: 'Split Editor',
},
'FullScreen', '|', 'Undo', 'Redo']
},
valueTemplate: value,
});
defaultRTE.appendTo('#markdownPreview');
});
let mdSource: any;
let mdSplit: HTMLElement;
let htmlPreview: any;
let defaultRTE: RichTextEditor;
let textArea: HTMLTextAreaElement;
let value: string = `***Overview***
The Rich Text Editor component is WYSIWYG ("what you see is what you get") editor used to create and edit the content and return valid HTML markup or markdown (MD) of the content. The editor provides a standard toolbar to format content using its commands. Modular library features to load the necessary functionality on demand. The toolbar contains commands to align the text, insert link, insert image, insert list, undo/redo operation, HTML view, and more.
***Key features***
- *Mode*: Provides IFRAME and DIV mode.
- *Module*: Modular library to load the necessary functionality on demand.
- *Toolbar*: Provide a fully customizable toolbar.
- *Editing*: HTML view to edit the source directly for developers.
- *Third-party Integration*: Supports to integrate third-party library.
- *Preview*: Preview the modified content before saving it.
- *Tools*: Handling images, hyperlinks, video, uploads and more.
- *Undo and Redo*: Undo/redo manager.
- *Lists*: Creates bulleted and numbered list.`;
function markDownConversion(): void {
if (mdSplit.classList.contains('e-active')) {
const id: string = defaultRTE.getID() + 'html-preview';
const htmlPreview: any = defaultRTE.element.querySelector('#' + id);
htmlPreview.innerHTML = marked((defaultRTE.contentModule.getEditPanel()).value);
}
}
function fullPreview(e: { [key: string]: string | boolean }): void {
const id: string = defaultRTE.getID() + 'html-preview';
htmlPreview = defaultRTE.element.querySelector('#' + id);
if ((mdSource.classList.contains('e-active') || mdSplit.classList.contains('e-active')) && e.mode) {
mdSource.classList.remove('e-active');
mdSplit.classList.remove('e-active');
mdSource.parentElement.title = 'Preview';
textArea.style.display = 'block';
textArea.style.width = '100%';
htmlPreview.style.display = 'none';
} else {
mdSource.classList.add('e-active');
mdSplit.classList.add('e-active');
if (!htmlPreview) {
htmlPreview = createElement('div', { className: 'e-content' });
htmlPreview.id = id;
(textArea as any).parentNode.appendChild(htmlPreview);
}
if (e.type === 'preview') {
textArea.style.display = 'none'; htmlPreview.classList.add('e-pre-source');
htmlPreview.style.width = '100%';
} else {
htmlPreview.classList.remove('e-pre-source');
textArea.style.width = '50%';
htmlPreview.style.width = '50%';
}
htmlPreview.style.display = 'block';
htmlPreview.innerHTML = marked((defaultRTE.contentModule.getEditPanel()).value);
mdSource.parentElement.title = 'Code View';
}
}
return (
<div id="rte-default" className='control-pane'>
<div className='control-section' id="rtePreview">
<div className="content-wrapper">
<div id="markdownPreview"/>
</div>
</div>
</div>
);
}
export default App;
Table
Rich Text Editor allows to insert Markdown table in edit panel with 2 X 2 rows and columns along with the heading.
To use table tool, add the CreateTable
item in toolbar items.
Insert table
To insert the table in Rich Text Editor, click the table
toolbar option to insert the table into Rich Text Editor content and this is the default way in all the devices.
Please refer the below sample and code snippets to add the table in Markdown editor
[Class-component]
/**
* Rich Text Editor - Markdown to HTML Sample
*/
import { isNullOrUndefined } from '@syncfusion/ej2-base';
import { createElement } from '@syncfusion/ej2-base';
import { Image, Link, MarkdownEditor, RichTextEditor, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
RichTextEditor.Inject(Image, Link, MarkdownEditor, Toolbar);
import * as React from 'react';
class App extends React.Component {
mdSource;
mdSplit;
htmlPreview;
defaultRTE;
textArea;
value = `***Overview***
The Rich Text Editor component is WYSIWYG ("what you see is what you get") editor used to create and edit the content and return valid HTML markup or markdown (MD) of the content. The editor provides a standard toolbar to format content using its commands. Modular library features to load the necessary functionality on demand. The toolbar contains commands to align the text, insert link, insert image, insert list, undo/redo operation, HTML view, and more.
***Key features***
- *Mode*: Provides IFRAME and DIV mode.
- *Module*: Modular library to load the necessary functionality on demand.
- *Toolbar*: Provide a fully customizable toolbar.
- *Editing*: HTML view to edit the source directly for developers.
- *Third-party Integration*: Supports to integrate third-party library.
- *Preview*: Preview the modified content before saving it.
- *Tools*: Handling images, hyperlinks, video, uploads and more.
- *Undo and Redo*: Undo/redo manager.
- *Lists*: Creates bulleted and numbered list.`;
componentDidMount() {
this.defaultRTE = new RichTextEditor({
actionComplete: (e) => {
if (e.targetItem === 'Maximize' && isNullOrUndefined(e.args)) {
this.fullPreview({ mode: true, type: '' });
}
else if (!this.mdSplit.parentElement.classList.contains('e-overlay')) {
if (e.targetItem === 'Minimize') {
this.textArea.style.display = 'block';
this.textArea.style.width = '100%';
if (this.htmlPreview) {
this.htmlPreview.style.display = 'none';
}
this.mdSplit.classList.remove('e-active');
this.mdSource.classList.remove('e-active');
}
this.markDownConversion();
}
setTimeout(() => {
this.defaultRTE.toolbarModule.refreshToolbarOverflow();
}, 400);
},
created: () => {
this.textArea = this.defaultRTE.contentModule.getEditPanel();
this.textArea.addEventListener('keyup', (e) => {
this.markDownConversion();
});
this.mdSource = document.getElementById('preview-code');
this.mdSource.addEventListener('click', (e) => {
this.fullPreview({ mode: true, type: 'preview' });
if (e.currentTarget.classList.contains('e-active')) {
this.defaultRTE.disableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'Undo', 'Redo', 'CreateTable']);
e.currentTarget.parentElement.previousElementSibling.classList.add('e-overlay');
}
else {
this.defaultRTE.enableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'Undo', 'Redo', 'CreateTable']);
e.currentTarget.parentElement.previousElementSibling.classList.remove('e-overlay');
}
});
this.mdSplit = document.getElementById('MD_Preview');
this.mdSplit.addEventListener('click', (e) => {
if (this.defaultRTE.element.classList.contains('e-rte-full-screen')) {
this.fullPreview({ mode: true, type: '' });
}
this.mdSource.classList.remove('e-active');
if (!this.defaultRTE.element.classList.contains('e-rte-full-screen')) {
this.defaultRTE.showFullScreen();
}
});
},
editorMode: 'Markdown',
height: '300px',
toolbarSettings: {
items: [
'Bold', 'Italic', 'StrikeThrough', '|', 'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'CreateTable', '|',
{
template: '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn">' +
'<span class="e-btn-icon e-md-preview e-preview e-icons"></span></button>',
tooltipText: 'Preview'
},
{
template: '<button id="MD_Preview" class="e-tbar-btn e-control e-btn e-icon-btn">' +
'<span class="e-btn-icon e-view-side e-icons"></span></button>',
tooltipText: 'Split Editor'
},
'FullScreen', '|', 'Undo', 'Redo'
]
},
valueTemplate: this.value
});
this.defaultRTE.appendTo('#markdownPreview');
}
markDownConversion() {
if (this.mdSplit.classList.contains('e-active')) {
const id = this.defaultRTE.getID() + 'html-preview';
const htmlPreview = this.defaultRTE.element.querySelector('#' + id);
htmlPreview.innerHTML = marked((this.defaultRTE.contentModule.getEditPanel()).value);
}
}
fullPreview(e) {
const id = this.defaultRTE.getID() + 'html-preview';
this.htmlPreview = this.defaultRTE.element.querySelector('#' + id);
if ((this.mdSource.classList.contains('e-active') || this.mdSplit.classList.contains('e-active')) && e.mode) {
this.mdSource.classList.remove('e-active');
this.mdSplit.classList.remove('e-active');
this.mdSource.parentElement.title = 'Preview';
this.textArea.style.display = 'block';
this.textArea.style.width = '100%';
this.htmlPreview.style.display = 'none';
}
else {
this.mdSource.classList.add('e-active');
this.mdSplit.classList.add('e-active');
if (!this.htmlPreview) {
this.htmlPreview = createElement('div', { className: 'e-content' });
this.htmlPreview.id = id;
this.textArea.parentNode.appendChild(this.htmlPreview);
}
if (e.type === 'preview') {
this.textArea.style.display = 'none';
this.htmlPreview.classList.add('e-pre-source');
this.htmlPreview.style.width = '100%';
}
else {
this.htmlPreview.classList.remove('e-pre-source');
this.textArea.style.width = '50%';
this.htmlPreview.style.width = '50%';
}
this.htmlPreview.style.display = 'block';
this.htmlPreview.innerHTML = marked((this.defaultRTE.contentModule.getEditPanel()).value);
this.mdSource.parentElement.title = 'Code View';
}
}
render() {
return (<div id="rte-default" className='control-pane'>
<div className='control-section' id="rtePreview">
<div className="content-wrapper">
<div id="markdownPreview"/>
</div>
</div>
</div>);
}
}
export default App;
/**
* Rich Text Editor - Markdown to HTML Sample
*/
import { isNullOrUndefined } from '@syncfusion/ej2-base';
import { createElement, KeyboardEventArgs } from '@syncfusion/ej2-base';
import { Image, Link, MarkdownEditor, RichTextEditor, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
RichTextEditor.Inject(Image, Link, MarkdownEditor, Toolbar);
import * as React from 'react';
class App extends React.Component<{},{}> {
public mdSource: HTMLElement;
public mdSplit: HTMLElement;
public htmlPreview: HTMLElement;
public defaultRTE: RichTextEditor;
public textArea: HTMLTextAreaElement;
public value: string = `***Overview***
The Rich Text Editor component is WYSIWYG ("what you see is what you get") editor used to create and edit the content and return valid HTML markup or markdown (MD) of the content. The editor provides a standard toolbar to format content using its commands. Modular library features to load the necessary functionality on demand. The toolbar contains commands to align the text, insert link, insert image, insert list, undo/redo operation, HTML view, and more.
***Key features***
- *Mode*: Provides IFRAME and DIV mode.
- *Module*: Modular library to load the necessary functionality on demand.
- *Toolbar*: Provide a fully customizable toolbar.
- *Editing*: HTML view to edit the source directly for developers.
- *Third-party Integration*: Supports to integrate third-party library.
- *Preview*: Preview the modified content before saving it.
- *Tools*: Handling images, hyperlinks, video, uploads and more.
- *Undo and Redo*: Undo/redo manager.
- *Lists*: Creates bulleted and numbered list.`;
public componentDidMount(): void {
this.defaultRTE = new RichTextEditor({
actionComplete: (e: any) => {
if (e.targetItem === 'Maximize' && isNullOrUndefined(e.args)) {
this.fullPreview({ mode: true, type: '' });
} else if (!(this as any).mdSplit.parentElement.classList.contains('e-overlay')) {
if (e.targetItem === 'Minimize') {
this.textArea.style.display = 'block';
this.textArea.style.width = '100%';
if (this.htmlPreview) { this.htmlPreview.style.display = 'none'; }
this.mdSplit.classList.remove('e-active');
this.mdSource.classList.remove('e-active');
}
this.markDownConversion();
}
setTimeout(() => {
this.defaultRTE.toolbarModule.refreshToolbarOverflow();
}, 400);
},
created: () => {
this.textArea = (this.defaultRTE as any).contentModule.getEditPanel();
this.textArea.addEventListener('keyup', (e: KeyboardEventArgs) => {
this.markDownConversion();
});
this.mdSource = document.getElementById('preview-code') as any;
this.mdSource.addEventListener('click', (e: MouseEvent) => {
this.fullPreview({ mode: true, type: 'preview' });
if ((e.currentTarget as HTMLElement).classList.contains('e-active')) {
this.defaultRTE.disableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'Undo', 'Redo', 'CreateTable']);
(e.currentTarget as any).parentElement.previousElementSibling.classList.add('e-overlay');
} else {
this.defaultRTE.enableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'Undo', 'Redo', 'CreateTable']);
(e.currentTarget as any).parentElement.previousElementSibling.classList.remove('e-overlay');
}
});
this.mdSplit = document.getElementById('MD_Preview') as any;
this.mdSplit.addEventListener('click', (e: MouseEvent) => {
if (this.defaultRTE.element.classList.contains('e-rte-full-screen')) {
this.fullPreview({ mode: true, type: '' });
}
this.mdSource.classList.remove('e-active');
if (!this.defaultRTE.element.classList.contains('e-rte-full-screen')) {
this.defaultRTE.showFullScreen();
}
});
},
editorMode: 'Markdown',
height: '300px',
toolbarSettings: {
items: [
'Bold', 'Italic', 'StrikeThrough', '|', 'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'CreateTable', '|',
{
template: '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn">' +
'<span class="e-btn-icon e-md-preview e-preview e-icons"></span></button>',
tooltipText: 'Preview'
},
{
template: '<button id="MD_Preview" class="e-tbar-btn e-control e-btn e-icon-btn">' +
'<span class="e-btn-icon e-view-side e-icons"></span></button>',
tooltipText: 'Split Editor'
},
'FullScreen', '|', 'Undo', 'Redo']
},
valueTemplate: this.value
});
this.defaultRTE.appendTo('#markdownPreview');
}
public markDownConversion(): void {
if (this.mdSplit.classList.contains('e-active')) {
const id: string = this.defaultRTE.getID() + 'html-preview';
const htmlPreview: any = this.defaultRTE.element.querySelector('#' + id);
htmlPreview.innerHTML = marked(((this.defaultRTE as any).contentModule.getEditPanel()).value);
}
}
public fullPreview(e: { [key: string]: string | boolean }): void {
const id: string = this.defaultRTE.getID() + 'html-preview';
this.htmlPreview = this.defaultRTE.element.querySelector('#' + id);
if ((this.mdSource.classList.contains('e-active') || this.mdSplit.classList.contains('e-active')) && e.mode) {
this.mdSource.classList.remove('e-active');
this.mdSplit.classList.remove('e-active');
this.mdSource.parentElement.title = 'Preview';
this.textArea.style.display = 'block';
this.textArea.style.width = '100%';
this.htmlPreview.style.display = 'none';
} else {
this.mdSource.classList.add('e-active');
this.mdSplit.classList.add('e-active');
if (!this.htmlPreview) {
this.htmlPreview = createElement('div', { className: 'e-content' });
this.htmlPreview.id = id;
(this.textArea as any).parentNode.appendChild(this.htmlPreview);
}
if (e.type === 'preview') {
this.textArea.style.display = 'none'; this.htmlPreview.classList.add('e-pre-source');
this.htmlPreview.style.width = '100%';
} else {
this.htmlPreview.classList.remove('e-pre-source');
this.textArea.style.width = '50%';
this.htmlPreview.style.width = '50%';
}
this.htmlPreview.style.display = 'block';
this.htmlPreview.innerHTML = marked(((this as any).defaultRTE.contentModule.getEditPanel()).value);
this.mdSource.parentElement.title = 'Code View';
}
}
public render() {
return (
<div id="rte-default" className='control-pane'>
<div className='control-section' id="rtePreview">
<div className="content-wrapper">
<div id="markdownPreview"/>
</div>
</div>
</div>
);
}
}
export default App;
[Functional-component]
/**
* Rich Text Editor - Markdown to HTML Sample
*/
import { isNullOrUndefined } from '@syncfusion/ej2-base';
import { createElement } from '@syncfusion/ej2-base';
import { Image, Link, MarkdownEditor, RichTextEditor, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
RichTextEditor.Inject(Image, Link, MarkdownEditor, Toolbar);
import * as React from 'react';
import { useEffect } from "react";
function App() {
useEffect(() => {
defaultRTE = new RichTextEditor({
actionComplete: (e) => {
if (e.targetItem === 'Maximize' && isNullOrUndefined(e.args)) {
fullPreview({ mode: true, type: '' });
}
else if (!this.mdSplit.parentElement.classList.contains('e-overlay')) {
if (e.targetItem === 'Minimize') {
textArea.style.display = 'block';
textArea.style.width = '100%';
if (htmlPreview) {
htmlPreview.style.display = 'none';
}
mdSplit.classList.remove('e-active');
mdSource.classList.remove('e-active');
}
markDownConversion();
}
setTimeout(() => {
defaultRTE.toolbarModule.refreshToolbarOverflow();
}, 400);
},
created: () => {
textArea = defaultRTE.contentModule.getEditPanel();
textArea.addEventListener('keyup', (e) => {
markDownConversion();
});
mdSource = document.getElementById('preview-code');
mdSource.addEventListener('click', (e) => {
fullPreview({ mode: true, type: 'preview' });
if (e.currentTarget.classList.contains('e-active')) {
defaultRTE.disableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'Undo', 'Redo', 'CreateTable']);
e.currentTarget.parentElement.previousElementSibling.classList.add('e-overlay');
}
else {
defaultRTE.enableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'Undo', 'Redo', 'CreateTable']);
e.currentTarget.parentElement.previousElementSibling.classList.remove('e-overlay');
}
});
mdSplit = document.getElementById('MD_Preview');
mdSplit.addEventListener('click', (e) => {
if (defaultRTE.element.classList.contains('e-rte-full-screen')) {
fullPreview({ mode: true, type: '' });
}
mdSource.classList.remove('e-active');
if (!defaultRTE.element.classList.contains('e-rte-full-screen')) {
defaultRTE.showFullScreen();
}
});
},
editorMode: 'Markdown',
height: '300px',
toolbarSettings: {
items: [
'Bold', 'Italic', 'StrikeThrough', '|', 'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'CreateTable', '|',
{
template: '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn">' +
'<span class="e-btn-icon e-md-preview e-preview e-icons"></span></button>',
tooltipText: 'Preview'
},
{
template: '<button id="MD_Preview" class="e-tbar-btn e-control e-btn e-icon-btn">' +
'<span class="e-btn-icon e-view-side e-icons"></span></button>',
tooltipText: 'Split Editor'
},
'FullScreen', '|', 'Undo', 'Redo'
]
},
valueTemplate: value
});
defaultRTE.appendTo('#markdownPreview');
});
let mdSource;
let mdSplit;
let htmlPreview;
let defaultRTE;
let textArea;
let value = `***Overview***
The Rich Text Editor component is WYSIWYG ("what you see is what you get") editor used to create and edit the content and return valid HTML markup or markdown (MD) of the content. The editor provides a standard toolbar to format content using its commands. Modular library features to load the necessary functionality on demand. The toolbar contains commands to align the text, insert link, insert image, insert list, undo/redo operation, HTML view, and more.
***Key features***
- *Mode*: Provides IFRAME and DIV mode.
- *Module*: Modular library to load the necessary functionality on demand.
- *Toolbar*: Provide a fully customizable toolbar.
- *Editing*: HTML view to edit the source directly for developers.
- *Third-party Integration*: Supports to integrate third-party library.
- *Preview*: Preview the modified content before saving it.
- *Tools*: Handling images, hyperlinks, video, uploads and more.
- *Undo and Redo*: Undo/redo manager.
- *Lists*: Creates bulleted and numbered list.`;
function markDownConversion() {
if (mdSplit.classList.contains('e-active')) {
const id = defaultRTE.getID() + 'html-preview';
const htmlPreview = defaultRTE.element.querySelector('#' + id);
htmlPreview.innerHTML = marked((defaultRTE.contentModule.getEditPanel()).value);
}
}
function fullPreview(e) {
const id = defaultRTE.getID() + 'html-preview';
htmlPreview = defaultRTE.element.querySelector('#' + id);
if ((mdSource.classList.contains('e-active') || mdSplit.classList.contains('e-active')) && e.mode) {
mdSource.classList.remove('e-active');
mdSplit.classList.remove('e-active');
mdSource.parentElement.title = 'Preview';
textArea.style.display = 'block';
textArea.style.width = '100%';
htmlPreview.style.display = 'none';
}
else {
mdSource.classList.add('e-active');
mdSplit.classList.add('e-active');
if (!htmlPreview) {
htmlPreview = createElement('div', { className: 'e-content' });
htmlPreview.id = id;
textArea.parentNode.appendChild(htmlPreview);
}
if (e.type === 'preview') {
textArea.style.display = 'none';
htmlPreview.classList.add('e-pre-source');
htmlPreview.style.width = '100%';
}
else {
htmlPreview.classList.remove('e-pre-source');
textArea.style.width = '50%';
htmlPreview.style.width = '50%';
}
htmlPreview.style.display = 'block';
htmlPreview.innerHTML = marked((defaultRTE.contentModule.getEditPanel()).value);
mdSource.parentElement.title = 'Code View';
}
}
return (<div id="rte-default" className='control-pane'>
<div className='control-section' id="rtePreview">
<div className="content-wrapper">
<div id="markdownPreview"/>
</div>
</div>
</div>);
}
export default App;
/**
* Rich Text Editor - Markdown to HTML Sample
*/
import { isNullOrUndefined } from '@syncfusion/ej2-base';
import { createElement, KeyboardEventArgs } from '@syncfusion/ej2-base';
import { Image, Link, MarkdownEditor, RichTextEditor, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
RichTextEditor.Inject(Image, Link, MarkdownEditor, Toolbar);
import * as React from 'react';
import { useEffect } from "react";
function App() {
useEffect(() => {
defaultRTE = new RichTextEditor({
actionComplete: (e: any) => {
if (e.targetItem === 'Maximize' && isNullOrUndefined(e.args)) {
fullPreview({ mode: true, type: '' });
} else if (!(this as any).mdSplit.parentElement.classList.contains('e-overlay')) {
if (e.targetItem === 'Minimize') {
textArea.style.display = 'block';
textArea.style.width = '100%';
if (htmlPreview) { htmlPreview.style.display = 'none'; }
mdSplit.classList.remove('e-active');
mdSource.classList.remove('e-active');
}
markDownConversion();
}
setTimeout(() => {
defaultRTE.toolbarModule.refreshToolbarOverflow();
}, 400);
},
created: () => {
textArea = (defaultRTE as any).contentModule.getEditPanel();
textArea.addEventListener('keyup', (e: KeyboardEventArgs) => {
markDownConversion();
});
mdSource = document.getElementById('preview-code') as any;
mdSource.addEventListener('click', (e: MouseEvent) => {
fullPreview({ mode: true, type: 'preview' });
if ((e.currentTarget as HTMLElement).classList.contains('e-active')) {
defaultRTE.disableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'Undo', 'Redo', 'CreateTable']);
(e.currentTarget as any).parentElement.previousElementSibling.classList.add('e-overlay');
} else {
defaultRTE.enableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'Undo', 'Redo', 'CreateTable']);
(e.currentTarget as any).parentElement.previousElementSibling.classList.remove('e-overlay');
}
});
mdSplit = document.getElementById('MD_Preview') as any;
mdSplit.addEventListener('click', (e: MouseEvent) => {
if (defaultRTE.element.classList.contains('e-rte-full-screen')) {
fullPreview({ mode: true, type: '' });
}
mdSource.classList.remove('e-active');
if (!defaultRTE.element.classList.contains('e-rte-full-screen')) {
defaultRTE.showFullScreen();
}
});
},
editorMode: 'Markdown',
height: '300px',
toolbarSettings: {
items: [
'Bold', 'Italic', 'StrikeThrough', '|', 'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'CreateTable', '|',
{
template: '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn">' +
'<span class="e-btn-icon e-md-preview e-preview e-icons"></span></button>',
tooltipText: 'Preview'
},
{
template: '<button id="MD_Preview" class="e-tbar-btn e-control e-btn e-icon-btn">' +
'<span class="e-btn-icon e-view-side e-icons"></span></button>',
tooltipText: 'Split Editor'
},
'FullScreen', '|', 'Undo', 'Redo']
},
valueTemplate: value
});
defaultRTE.appendTo('#markdownPreview');
});
let mdSource: HTMLElement;
let mdSplit: HTMLElement;
let htmlPreview: HTMLElement;
let defaultRTE: RichTextEditor;
let textArea: HTMLTextAreaElement;
let value: string = `***Overview***
The Rich Text Editor component is WYSIWYG ("what you see is what you get") editor used to create and edit the content and return valid HTML markup or markdown (MD) of the content. The editor provides a standard toolbar to format content using its commands. Modular library features to load the necessary functionality on demand. The toolbar contains commands to align the text, insert link, insert image, insert list, undo/redo operation, HTML view, and more.
***Key features***
- *Mode*: Provides IFRAME and DIV mode.
- *Module*: Modular library to load the necessary functionality on demand.
- *Toolbar*: Provide a fully customizable toolbar.
- *Editing*: HTML view to edit the source directly for developers.
- *Third-party Integration*: Supports to integrate third-party library.
- *Preview*: Preview the modified content before saving it.
- *Tools*: Handling images, hyperlinks, video, uploads and more.
- *Undo and Redo*: Undo/redo manager.
- *Lists*: Creates bulleted and numbered list.`;
function markDownConversion(): void {
if (mdSplit.classList.contains('e-active')) {
const id: string = defaultRTE.getID() + 'html-preview';
const htmlPreview: any = defaultRTE.element.querySelector('#' + id);
htmlPreview.innerHTML = marked(((defaultRTE as any).contentModule.getEditPanel()).value);
}
}
function fullPreview(e: { [key: string]: string | boolean }): void {
const id: string = defaultRTE.getID() + 'html-preview';
htmlPreview = defaultRTE.element.querySelector('#' + id);
if ((mdSource.classList.contains('e-active') || mdSplit.classList.contains('e-active')) && e.mode) {
mdSource.classList.remove('e-active');
mdSplit.classList.remove('e-active');
mdSource.parentElement.title = 'Preview';
textArea.style.display = 'block';
textArea.style.width = '100%';
htmlPreview.style.display = 'none';
} else {
mdSource.classList.add('e-active');
mdSplit.classList.add('e-active');
if (!htmlPreview) {
htmlPreview = createElement('div', { className: 'e-content' });
htmlPreview.id = id;
(textArea as any).parentNode.appendChild(htmlPreview);
}
if (e.type === 'preview') {
textArea.style.display = 'none'; htmlPreview.classList.add('e-pre-source');
htmlPreview.style.width = '100%';
} else {
htmlPreview.classList.remove('e-pre-source');
textArea.style.width = '50%';
htmlPreview.style.width = '50%';
}
htmlPreview.style.display = 'block';
htmlPreview.innerHTML = marked((defaultRTE.contentModule.getEditPanel()).value);
mdSource.parentElement.title = 'Code View';
}
}
return (
<div id="rte-default" className='control-pane'>
<div className='control-section' id="rtePreview">
<div className="content-wrapper">
<div id="markdownPreview"/>
</div>
</div>
</div>
);
}
export default App;
Changing table constants
The Markdown table constants can be changed for the table heading and the column names.
[Class-component]
/**
* Rich Text Editor - Markdown to HTML Sample
*/
import { L10n } from '@syncfusion/ej2-base';
import { isNullOrUndefined } from '@syncfusion/ej2-base';
import { createElement } from '@syncfusion/ej2-base';
import { Image, Link, MarkdownEditor, RichTextEditor, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
RichTextEditor.Inject(Image, Link, MarkdownEditor, Toolbar);
import * as React from 'react';
L10n.load({
'en-US': {
'richtexteditor': {
'TableColText': 'Cell',
'TableHeadingText': 'Header'
}
}
});
class App extends React.Component {
mdSource;
mdSplit;
htmlPreview;
defaultRTE;
textArea;
value = `***Overview***
The Rich Text Editor component is WYSIWYG ("what you see is what you get") editor used to create and edit the content and return valid HTML markup or markdown (MD) of the content. The editor provides a standard toolbar to format content using its commands. Modular library features to load the necessary functionality on demand. The toolbar contains commands to align the text, insert link, insert image, insert list, undo/redo operation, HTML view, and more.
***Key features***
- *Mode*: Provides IFRAME and DIV mode.
- *Module*: Modular library to load the necessary functionality on demand.
- *Toolbar*: Provide a fully customizable toolbar.
- *Editing*: HTML view to edit the source directly for developers.
- *Third-party Integration*: Supports to integrate third-party library.
- *Preview*: Preview the modified content before saving it.
- *Tools*: Handling images, hyperlinks, video, uploads and more.
- *Undo and Redo*: Undo/redo manager.
- *Lists*: Creates bulleted and numbered list.`;
componentDidMount() {
this.defaultRTE = new RichTextEditor({
actionComplete: (e) => {
if (e.targetItem === 'Maximize' && isNullOrUndefined(e.args)) {
this.fullPreview({ mode: true, type: '' });
}
else if (!this.mdSplit.parentElement.classList.contains('e-overlay')) {
if (e.targetItem === 'Minimize') {
this.textArea.style.display = 'block';
this.textArea.style.width = '100%';
if (this.htmlPreview) {
this.htmlPreview.style.display = 'none';
}
this.mdSplit.classList.remove('e-active');
this.mdSource.classList.remove('e-active');
}
this.markDownConversion();
}
setTimeout(() => {
this.defaultRTE.toolbarModule.refreshToolbarOverflow();
}, 400);
},
created: () => {
this.textArea = this.defaultRTE.contentModule.getEditPanel();
this.textArea.addEventListener('keyup', (e) => {
this.markDownConversion();
});
this.mdSource = document.getElementById('preview-code');
this.mdSource.addEventListener('click', (e) => {
this.fullPreview({ mode: true, type: 'preview' });
if (e.currentTarget.classList.contains('e-active')) {
this.defaultRTE.disableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'Undo', 'Redo', 'CreateTable']);
e.currentTarget.parentElement.previousElementSibling.classList.add('e-overlay');
}
else {
this.defaultRTE.enableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'Undo', 'Redo', 'CreateTable']);
e.currentTarget.parentElement.previousElementSibling.classList.remove('e-overlay');
}
});
this.mdSplit = document.getElementById('MD_Preview');
this.mdSplit.addEventListener('click', (e) => {
if (this.defaultRTE.element.classList.contains('e-rte-full-screen')) {
this.fullPreview({ mode: true, type: '' });
}
this.mdSource.classList.remove('e-active');
if (!this.defaultRTE.element.classList.contains('e-rte-full-screen')) {
this.defaultRTE.showFullScreen();
}
});
},
editorMode: 'Markdown',
height: '300px',
toolbarSettings: {
items: [
'Bold', 'Italic', 'StrikeThrough', '|', 'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'CreateTable', '|',
{
template: '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn">' +
'<span class="e-btn-icon e-md-preview e-preview e-icons"></span></button>',
tooltipText: 'Preview'
},
{
template: '<button id="MD_Preview" class="e-tbar-btn e-control e-btn e-icon-btn">' +
'<span class="e-btn-icon e-view-side e-icons"></span></button>',
tooltipText: 'Split Editor'
},
'FullScreen', '|', 'Undo', 'Redo'
]
},
valueTemplate: this.value,
});
this.defaultRTE.appendTo('#markdownPreview');
}
markDownConversion() {
if (this.mdSplit.classList.contains('e-active')) {
const id = this.defaultRTE.getID() + 'html-preview';
const htmlPreview = this.defaultRTE.element.querySelector('#' + id);
htmlPreview.innerHTML = marked((this.defaultRTE.contentModule.getEditPanel()).value);
}
}
fullPreview(e) {
const id = this.defaultRTE.getID() + 'html-preview';
this.htmlPreview = this.defaultRTE.element.querySelector('#' + id);
if ((this.mdSource.classList.contains('e-active') || this.mdSplit.classList.contains('e-active')) && e.mode) {
this.mdSource.classList.remove('e-active');
this.mdSplit.classList.remove('e-active');
this.mdSource.parentElement.title = 'Preview';
this.textArea.style.display = 'block';
this.textArea.style.width = '100%';
this.htmlPreview.style.display = 'none';
}
else {
this.mdSource.classList.add('e-active');
this.mdSplit.classList.add('e-active');
if (!this.htmlPreview) {
this.htmlPreview = createElement('div', { className: 'e-content' });
this.htmlPreview.id = id;
this.textArea.parentNode.appendChild(this.htmlPreview);
}
if (e.type === 'preview') {
this.textArea.style.display = 'none';
this.htmlPreview.classList.add('e-pre-source');
this.htmlPreview.style.width = '100%';
}
else {
this.htmlPreview.classList.remove('e-pre-source');
this.textArea.style.width = '50%';
this.htmlPreview.style.width = '50%';
}
this.htmlPreview.style.display = 'block';
this.htmlPreview.innerHTML = marked((this.defaultRTE.contentModule.getEditPanel()).value);
this.mdSource.parentElement.title = 'Code View';
}
}
render() {
return (<div id="rte-default" className='control-pane'>
<div className='control-section' id="rtePreview">
<div className="content-wrapper">
<div id="markdownPreview"/>
</div>
</div>
</div>);
}
}
export default App;
/**
* Rich Text Editor - Markdown to HTML Sample
*/
import { L10n } from '@syncfusion/ej2-base';
import { isNullOrUndefined } from '@syncfusion/ej2-base';
import { createElement, KeyboardEventArgs } from '@syncfusion/ej2-base';
import { Image, Link, MarkdownEditor, RichTextEditor, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
RichTextEditor.Inject(Image, Link, MarkdownEditor, Toolbar);
import * as React from 'react';
L10n.load({
'en-US': {
'richtexteditor': {
'TableColText': 'Cell',
'TableHeadingText': 'Header'
}
}
});
class App extends React.Component<{},{}> {
public mdSource: HTMLElement;
public mdSplit: HTMLElement;
public htmlPreview: HTMLElement;
public defaultRTE: RichTextEditor;
public textArea: HTMLTextAreaElement;
public value: string = `***Overview***
The Rich Text Editor component is WYSIWYG ("what you see is what you get") editor used to create and edit the content and return valid HTML markup or markdown (MD) of the content. The editor provides a standard toolbar to format content using its commands. Modular library features to load the necessary functionality on demand. The toolbar contains commands to align the text, insert link, insert image, insert list, undo/redo operation, HTML view, and more.
***Key features***
- *Mode*: Provides IFRAME and DIV mode.
- *Module*: Modular library to load the necessary functionality on demand.
- *Toolbar*: Provide a fully customizable toolbar.
- *Editing*: HTML view to edit the source directly for developers.
- *Third-party Integration*: Supports to integrate third-party library.
- *Preview*: Preview the modified content before saving it.
- *Tools*: Handling images, hyperlinks, video, uploads and more.
- *Undo and Redo*: Undo/redo manager.
- *Lists*: Creates bulleted and numbered list.`;
public componentDidMount(): void {
this.defaultRTE = new RichTextEditor({
actionComplete: (e: any) => {
if (e.targetItem === 'Maximize' && isNullOrUndefined(e.args)) {
this.fullPreview({ mode: true, type: '' });
} else if (!(this.mdSplit as any).parentElement.classList.contains('e-overlay')) {
if (e.targetItem === 'Minimize') {
this.textArea.style.display = 'block';
this.textArea.style.width = '100%';
if (this.htmlPreview) { this.htmlPreview.style.display = 'none'; }
this.mdSplit.classList.remove('e-active');
this.mdSource.classList.remove('e-active');
}
this.markDownConversion();
}
setTimeout(() => {
this.defaultRTE.toolbarModule.refreshToolbarOverflow();
}, 400);
},
created: () => {
this.textArea = (this.defaultRTE as any).contentModule.getEditPanel();
this.textArea.addEventListener('keyup', (e: KeyboardEventArgs) => {
this.markDownConversion();
});
this.mdSource = document.getElementById('preview-code') as any;
this.mdSource.addEventListener('click', (e: MouseEvent) => {
this.fullPreview({ mode: true, type: 'preview' });
if ((e.currentTarget as HTMLElement).classList.contains('e-active')) {
this.defaultRTE.disableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'Undo', 'Redo', 'CreateTable']);
(e.currentTarget as any).parentElement.previousElementSibling.classList.add('e-overlay');
} else {
this.defaultRTE.enableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'Undo', 'Redo', 'CreateTable']);
(e.currentTarget as any).parentElement.previousElementSibling.classList.remove('e-overlay');
}
});
this.mdSplit = document.getElementById('MD_Preview') as any;
this.mdSplit.addEventListener('click', (e: MouseEvent) => {
if (this.defaultRTE.element.classList.contains('e-rte-full-screen')) {
this.fullPreview({ mode: true, type: '' });
}
this.mdSource.classList.remove('e-active');
if (!this.defaultRTE.element.classList.contains('e-rte-full-screen')) {
this.defaultRTE.showFullScreen();
}
});
},
editorMode: 'Markdown',
height: '300px',
toolbarSettings: {
items: [
'Bold', 'Italic', 'StrikeThrough', '|', 'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'CreateTable', '|',
{
template: '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn">' +
'<span class="e-btn-icon e-md-preview e-preview e-icons"></span></button>',
tooltipText: 'Preview'
},
{
template: '<button id="MD_Preview" class="e-tbar-btn e-control e-btn e-icon-btn">' +
'<span class="e-btn-icon e-view-side e-icons"></span></button>',
tooltipText: 'Split Editor'
},
'FullScreen', '|', 'Undo', 'Redo']
},
valueTemplate: this.value,
});
this.defaultRTE.appendTo('#markdownPreview');
}
public markDownConversion(): void {
if (this.mdSplit.classList.contains('e-active')) {
const id: string = this.defaultRTE.getID() + 'html-preview';
const htmlPreview: HTMLElement = this.defaultRTE.element.querySelector('#' + id) as any;
htmlPreview.innerHTML = marked(((this.defaultRTE as any).contentModule.getEditPanel()).value);
}
}
public fullPreview(e: { [key: string]: string | boolean }): void {
const id: string = this.defaultRTE.getID() + 'html-preview';
this.htmlPreview = this.defaultRTE.element.querySelector('#' + id);
if ((this.mdSource.classList.contains('e-active') || this.mdSplit.classList.contains('e-active')) && e.mode) {
this.mdSource.classList.remove('e-active');
this.mdSplit.classList.remove('e-active');
this.mdSource.parentElement.title = 'Preview';
this.textArea.style.display = 'block';
this.textArea.style.width = '100%';
this.htmlPreview.style.display = 'none';
} else {
this.mdSource.classList.add('e-active');
this.mdSplit.classList.add('e-active');
if (!this.htmlPreview) {
this.htmlPreview = createElement('div', { className: 'e-content' });
this.htmlPreview.id = id;
(this.textArea as any).parentNode.appendChild(this.htmlPreview);
}
if (e.type === 'preview') {
this.textArea.style.display = 'none'; this.htmlPreview.classList.add('e-pre-source');
this.htmlPreview.style.width = '100%';
} else {
this.htmlPreview.classList.remove('e-pre-source');
this.textArea.style.width = '50%';
this.htmlPreview.style.width = '50%';
}
this.htmlPreview.style.display = 'block';
this.htmlPreview.innerHTML = marked(((this as any).defaultRTE.contentModule.getEditPanel()).value);
this.mdSource.parentElement.title = 'Code View';
}
}
public render() {
return (
<div id="rte-default" className='control-pane'>
<div className='control-section' id="rtePreview">
<div className="content-wrapper">
<div id="markdownPreview"/>
</div>
</div>
</div>
);
}
}
export default App;
[Functional-component]
/**
* Rich Text Editor - Markdown to HTML Sample
*/
import { L10n } from '@syncfusion/ej2-base';
import { isNullOrUndefined } from '@syncfusion/ej2-base';
import { createElement } from '@syncfusion/ej2-base';
import { Image, Link, MarkdownEditor, RichTextEditor, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
RichTextEditor.Inject(Image, Link, MarkdownEditor, Toolbar);
import * as React from 'react';
import { useEffect } from "react";
L10n.load({
'en-US': {
'richtexteditor': {
'TableColText': 'Cell',
'TableHeadingText': 'Header'
}
}
});
function App() {
useEffect(() => {
defaultRTE = new RichTextEditor({
actionComplete: (e) => {
if (e.targetItem === 'Maximize' && isNullOrUndefined(e.args)) {
fullPreview({ mode: true, type: '' });
}
else if (!mdSplit.parentElement.classList.contains('e-overlay')) {
if (e.targetItem === 'Minimize') {
textArea.style.display = 'block';
textArea.style.width = '100%';
if (htmlPreview) {
htmlPreview.style.display = 'none';
}
mdSplit.classList.remove('e-active');
mdSource.classList.remove('e-active');
}
markDownConversion();
}
setTimeout(() => {
defaultRTE.toolbarModule.refreshToolbarOverflow();
}, 400);
},
created: () => {
textArea = defaultRTE.contentModule.getEditPanel();
textArea.addEventListener('keyup', (e) => {
markDownConversion();
});
mdSource = document.getElementById('preview-code');
mdSource.addEventListener('click', (e) => {
fullPreview({ mode: true, type: 'preview' });
if (e.currentTarget.classList.contains('e-active')) {
defaultRTE.disableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'Undo', 'Redo', 'CreateTable']);
e.currentTarget.parentElement.previousElementSibling.classList.add('e-overlay');
}
else {
defaultRTE.enableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'Undo', 'Redo', 'CreateTable']);
e.currentTarget.parentElement.previousElementSibling.classList.remove('e-overlay');
}
});
mdSplit = document.getElementById('MD_Preview');
mdSplit.addEventListener('click', (e) => {
if (defaultRTE.element.classList.contains('e-rte-full-screen')) {
fullPreview({ mode: true, type: '' });
}
mdSource.classList.remove('e-active');
if (!defaultRTE.element.classList.contains('e-rte-full-screen')) {
defaultRTE.showFullScreen();
}
});
},
editorMode: 'Markdown',
height: '300px',
toolbarSettings: {
items: [
'Bold', 'Italic', 'StrikeThrough', '|', 'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'CreateTable', '|',
{
template: '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn">' +
'<span class="e-btn-icon e-md-preview e-preview e-icons"></span></button>',
tooltipText: 'Preview'
},
{
template: '<button id="MD_Preview" class="e-tbar-btn e-control e-btn e-icon-btn">' +
'<span class="e-btn-icon e-view-side e-icons"></span></button>',
tooltipText: 'Split Editor'
},
'FullScreen', '|', 'Undo', 'Redo'
]
},
valueTemplate: value,
});
defaultRTE.appendTo('#markdownPreview');
});
let mdSource;
let mdSplit;
let htmlPreview;
let defaultRTE;
let textArea;
let value = `***Overview***
The Rich Text Editor component is WYSIWYG ("what you see is what you get") editor used to create and edit the content and return valid HTML markup or markdown (MD) of the content. The editor provides a standard toolbar to format content using its commands. Modular library features to load the necessary functionality on demand. The toolbar contains commands to align the text, insert link, insert image, insert list, undo/redo operation, HTML view, and more.
***Key features***
- *Mode*: Provides IFRAME and DIV mode.
- *Module*: Modular library to load the necessary functionality on demand.
- *Toolbar*: Provide a fully customizable toolbar.
- *Editing*: HTML view to edit the source directly for developers.
- *Third-party Integration*: Supports to integrate third-party library.
- *Preview*: Preview the modified content before saving it.
- *Tools*: Handling images, hyperlinks, video, uploads and more.
- *Undo and Redo*: Undo/redo manager.
- *Lists*: Creates bulleted and numbered list.`;
function markDownConversion() {
if (mdSplit.classList.contains('e-active')) {
const id = defaultRTE.getID() + 'html-preview';
const htmlPreview = defaultRTE.element.querySelector('#' + id);
htmlPreview.innerHTML = marked((defaultRTE.contentModule.getEditPanel()).value);
}
}
function fullPreview(e) {
const id = defaultRTE.getID() + 'html-preview';
htmlPreview = defaultRTE.element.querySelector('#' + id);
if ((mdSource.classList.contains('e-active') || mdSplit.classList.contains('e-active')) && e.mode) {
mdSource.classList.remove('e-active');
mdSplit.classList.remove('e-active');
mdSource.parentElement.title = 'Preview';
textArea.style.display = 'block';
textArea.style.width = '100%';
htmlPreview.style.display = 'none';
}
else {
mdSource.classList.add('e-active');
mdSplit.classList.add('e-active');
if (!htmlPreview) {
htmlPreview = createElement('div', { className: 'e-content' });
htmlPreview.id = id;
textArea.parentNode.appendChild(htmlPreview);
}
if (e.type === 'preview') {
textArea.style.display = 'none';
htmlPreview.classList.add('e-pre-source');
htmlPreview.style.width = '100%';
}
else {
htmlPreview.classList.remove('e-pre-source');
textArea.style.width = '50%';
htmlPreview.style.width = '50%';
}
htmlPreview.style.display = 'block';
htmlPreview.innerHTML = marked((defaultRTE.contentModule.getEditPanel()).value);
mdSource.parentElement.title = 'Code View';
}
}
return (<div id="rte-default" className='control-pane'>
<div className='control-section' id="rtePreview">
<div className="content-wrapper">
<div id="markdownPreview"/>
</div>
</div>
</div>);
}
export default App;
/**
* Rich Text Editor - Markdown to HTML Sample
*/
import { L10n } from '@syncfusion/ej2-base';
import { isNullOrUndefined } from '@syncfusion/ej2-base';
import { createElement, KeyboardEventArgs } from '@syncfusion/ej2-base';
import { Image, Link, MarkdownEditor, RichTextEditor, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
RichTextEditor.Inject(Image, Link, MarkdownEditor, Toolbar);
import * as React from 'react';
import { useEffect } from "react";
L10n.load({
'en-US': {
'richtexteditor': {
'TableColText': 'Cell',
'TableHeadingText': 'Header'
}
}
});
function App() {
useEffect(() => {
defaultRTE = new RichTextEditor({
actionComplete: (e: any) => {
if (e.targetItem === 'Maximize' && isNullOrUndefined(e.args)) {
fullPreview({ mode: true, type: '' });
} else if (!(mdSplit as any).parentElement.classList.contains('e-overlay')) {
if (e.targetItem === 'Minimize') {
textArea.style.display = 'block';
textArea.style.width = '100%';
if (htmlPreview) { htmlPreview.style.display = 'none'; }
mdSplit.classList.remove('e-active');
mdSource.classList.remove('e-active');
}
markDownConversion();
}
setTimeout(() => {
defaultRTE.toolbarModule.refreshToolbarOverflow();
}, 400);
},
created: () => {
textArea = (defaultRTE as any).contentModule.getEditPanel();
textArea.addEventListener('keyup', (e: KeyboardEventArgs) => {
markDownConversion();
});
mdSource = document.getElementById('preview-code') as any;
mdSource.addEventListener('click', (e: MouseEvent) => {
fullPreview({ mode: true, type: 'preview' });
if ((e.currentTarget as HTMLElement).classList.contains('e-active')) {
defaultRTE.disableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'Undo', 'Redo', 'CreateTable']);
(e.currentTarget as any).parentElement.previousElementSibling.classList.add('e-overlay');
} else {
defaultRTE.enableToolbarItem(['Bold', 'Italic', 'StrikeThrough', '|',
'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'Undo', 'Redo', 'CreateTable']);
(e.currentTarget as any).parentElement.previousElementSibling.classList.remove('e-overlay');
}
});
mdSplit = document.getElementById('MD_Preview') as any;
mdSplit.addEventListener('click', (e: MouseEvent) => {
if (defaultRTE.element.classList.contains('e-rte-full-screen')) {
fullPreview({ mode: true, type: '' });
}
mdSource.classList.remove('e-active');
if (!defaultRTE.element.classList.contains('e-rte-full-screen')) {
defaultRTE.showFullScreen();
}
});
},
editorMode: 'Markdown',
height: '300px',
toolbarSettings: {
items: [
'Bold', 'Italic', 'StrikeThrough', '|', 'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', 'CreateTable', '|',
{
template: '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn">' +
'<span class="e-btn-icon e-md-preview e-preview e-icons"></span></button>',
tooltipText: 'Preview'
},
{
template: '<button id="MD_Preview" class="e-tbar-btn e-control e-btn e-icon-btn">' +
'<span class="e-btn-icon e-view-side e-icons"></span></button>',
tooltipText: 'Split Editor'
},
'FullScreen', '|', 'Undo', 'Redo']
},
valueTemplate: value,
});
defaultRTE.appendTo('#markdownPreview');
});
let mdSource: HTMLElement;
let mdSplit: HTMLElement;
let htmlPreview: HTMLElement;
let defaultRTE: RichTextEditor;
let textArea: HTMLTextAreaElement;
let value: string = `***Overview***
The Rich Text Editor component is WYSIWYG ("what you see is what you get") editor used to create and edit the content and return valid HTML markup or markdown (MD) of the content. The editor provides a standard toolbar to format content using its commands. Modular library features to load the necessary functionality on demand. The toolbar contains commands to align the text, insert link, insert image, insert list, undo/redo operation, HTML view, and more.
***Key features***
- *Mode*: Provides IFRAME and DIV mode.
- *Module*: Modular library to load the necessary functionality on demand.
- *Toolbar*: Provide a fully customizable toolbar.
- *Editing*: HTML view to edit the source directly for developers.
- *Third-party Integration*: Supports to integrate third-party library.
- *Preview*: Preview the modified content before saving it.
- *Tools*: Handling images, hyperlinks, video, uploads and more.
- *Undo and Redo*: Undo/redo manager.
- *Lists*: Creates bulleted and numbered list.`;
function markDownConversion(): void {
if (mdSplit.classList.contains('e-active')) {
const id: string = defaultRTE.getID() + 'html-preview';
const htmlPreview: HTMLElement = defaultRTE.element.querySelector('#' + id) as any;
htmlPreview.innerHTML = marked(((defaultRTE as any).contentModule.getEditPanel()).value);
}
}
function fullPreview(e: { [key: string]: string | boolean }): void {
const id: string = defaultRTE.getID() + 'html-preview';
htmlPreview = defaultRTE.element.querySelector('#' + id);
if ((mdSource.classList.contains('e-active') || mdSplit.classList.contains('e-active')) && e.mode) {
mdSource.classList.remove('e-active');
mdSplit.classList.remove('e-active');
mdSource.parentElement.title = 'Preview';
textArea.style.display = 'block';
textArea.style.width = '100%';
htmlPreview.style.display = 'none';
} else {
mdSource.classList.add('e-active');
mdSplit.classList.add('e-active');
if (!htmlPreview) {
htmlPreview = createElement('div', { className: 'e-content' });
htmlPreview.id = id;
(textArea as any).parentNode.appendChild(htmlPreview);
}
if (e.type === 'preview') {
textArea.style.display = 'none'; htmlPreview.classList.add('e-pre-source');
htmlPreview.style.width = '100%';
} else {
htmlPreview.classList.remove('e-pre-source');
textArea.style.width = '50%';
htmlPreview.style.width = '50%';
}
htmlPreview.style.display = 'block';
htmlPreview.innerHTML = marked((defaultRTE.contentModule.getEditPanel()).value);
mdSource.parentElement.title = 'Code View';
}
}
return (
<div id="rte-default" className='control-pane'>
<div className='control-section' id="rtePreview">
<div className="content-wrapper">
<div id="markdownPreview"/>
</div>
</div>
</div>
);
}
export default App;
Custom format
The Rich Text Editor allows you to customize the markdown syntax by overriding its default syntax. Configure the customized markdown syntax using the formatter property.
This sample demonstrates how to customize tags of markdown formatting.
For example, apply +
to Unordered list, apply 1., 2., 3.
to Ordered list, for bold, __
, and for italic _
.
[Class-component]
/**
* Rich Text Editor - Markdown - Custom Format Sample
*/
import { createElement } from '@syncfusion/ej2-base';
import { Image, Inject, Link, MarkdownEditor, MarkdownFormatter, QuickToolbar, RichTextEditorComponent, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
import * as React from 'react';
class App extends React.Component {
rteObj;
mdSource;
mdSplit;
htmlPreview;
defaultRTE;
textArea;
// set the value to Rich Text Editor
template = `The sample is configured with customized markdown syntax using the __formatter__ property. Type the content and click the toolbar item to view customized markdown syntax. For unordered list, you need to add a plus sign before the word (e.g., + list1). Or To make a phrase bold, you need to add two underscores before and after the phrase (e.g., __this text is bold__).`;
// Rich Text Editor items list
items = ['Bold', 'Italic', 'StrikeThrough', '|',
'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', '|',
{
template: '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn">' +
'<span class="e-btn-icon e-icons e-md-preview"></span></button>',
tooltipText: 'Preview',
}, 'Undo', 'Redo'];
mdsource;
mdPreview;
// Rich Text Editor ToolbarSettings
toolbarSettings = {
items: this.items
};
formatter = new MarkdownFormatter({
formatTags: {
'Blockquote': '> '
},
listTags: { 'OL': '1., 2., 3.', 'UL': '+ ' },
selectionTags: { 'Bold': '__', 'Italic': '_' }
});
markDownConversion() {
if (this.mdsource.classList.contains('e-active')) {
const id = this.rteObj.getID() + 'html-view';
const htmlPreview = this.rteObj.element.querySelector('#' + id);
htmlPreview.innerHTML = marked((this.rteObj.contentModule.getEditPanel()).value);
}
}
fullPreview(e) {
const id = this.defaultRTE.getID() + 'html-preview';
this.htmlPreview = this.defaultRTE.element.querySelector('#' + id);
if ((this.mdSource.classList.contains('e-active') || this.mdSplit.classList.contains('e-active')) && e.mode) {
this.mdSource.classList.remove('e-active');
this.mdSplit.classList.remove('e-active');
this.mdSource.parentElement.title = 'Preview';
this.textArea.style.display = 'block';
this.textArea.style.width = '100%';
this.htmlPreview.style.display = 'none';
}
else {
this.mdSource.classList.add('e-active');
this.mdSplit.classList.add('e-active');
if (!this.htmlPreview) {
this.htmlPreview = createElement('div', { className: 'e-content' });
this.htmlPreview.id = id;
this.textArea.parentNode.appendChild(this.htmlPreview);
}
if (e.type === 'preview') {
this.textArea.style.display = 'none';
this.htmlPreview.classList.add('e-pre-source');
this.htmlPreview.style.width = '100%';
}
else {
this.htmlPreview.classList.remove('e-pre-source');
this.textArea.style.width = '50%';
this.htmlPreview.style.width = '50%';
}
this.htmlPreview.style.display = 'block';
this.htmlPreview.innerHTML = marked((this.defaultRTE.contentModule.getEditPanel()).value);
this.mdSource.parentElement.title = 'Code View';
}
}
render() {
return (<RichTextEditorComponent id="markdownRTE" ref={(richtexteditor) => { this.rteObj = richtexteditor; }} height='260px' editorMode='Markdown' formatter={this.formatter} valueTemplate={this.template} toolbarSettings={this.toolbarSettings}>
<Inject services={[MarkdownEditor, Toolbar, Image, Link, QuickToolbar]}/>
</RichTextEditorComponent>);
}
}
export default App;
/**
* Rich Text Editor - Markdown - Custom Format Sample
*/
import { createElement, KeyboardEventArgs } from '@syncfusion/ej2-base';
import { Image, Inject, Link, MarkdownEditor, MarkdownFormatter, QuickToolbar, RichTextEditorComponent, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
import * as React from 'react';
class App extends React.Component<{},{}> {
public rteObj: RichTextEditorComponent;
public mdSource: HTMLElement;
public mdSplit: HTMLElement;
public htmlPreview: HTMLElement;
public defaultRTE: RichTextEditor;
public textArea: HTMLTextAreaElement;
// set the value to Rich Text Editor
public template: string = `The sample is configured with customized markdown syntax using the __formatter__ property. Type the content and click the toolbar item to view customized markdown syntax. For unordered list, you need to add a plus sign before the word (e.g., + list1). Or To make a phrase bold, you need to add two underscores before and after the phrase (e.g., __this text is bold__).`;
// Rich Text Editor items list
public items: object = ['Bold', 'Italic', 'StrikeThrough', '|',
'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', '|',
{
template: '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn">' +
'<span class="e-btn-icon e-icons e-md-preview"></span></button>',
tooltipText: 'Preview',
}, 'Undo', 'Redo'];
public mdsource: HTMLElement;
public mdPreview: HTMLElement;
// Rich Text Editor ToolbarSettings
public toolbarSettings: object = {
items: this.items
};
public formatter = new MarkdownFormatter({
formatTags: {
'Blockquote': '> '
},
listTags: { 'OL': '1., 2., 3.', 'UL': '+ ' },
selectionTags: {'Bold': '__', 'Italic': '_'}
});
public markDownConversion(): void {
if (this.mdsource.classList.contains('e-active')) {
const id: string = (this.rteObj as any).getID() + 'html-view';
const htmlPreview: HTMLElement = (this.rteObj as any).element.querySelector('#' + id);
htmlPreview.innerHTML = marked(((this.rteObj as any).contentModule.getEditPanel()).value);
}
}
public fullPreview(e: { [key: string]: string | boolean }): void {
const id: string = this.defaultRTE.getID() + 'html-preview';
this.htmlPreview = this.defaultRTE.element.querySelector('#' + id);
if ((this.mdSource.classList.contains('e-active') || this.mdSplit.classList.contains('e-active')) && e.mode) {
this.mdSource.classList.remove('e-active');
this.mdSplit.classList.remove('e-active');
this.mdSource.parentElement.title = 'Preview';
this.textArea.style.display = 'block';
this.textArea.style.width = '100%';
this.htmlPreview.style.display = 'none';
} else {
this.mdSource.classList.add('e-active');
this.mdSplit.classList.add('e-active');
if (!this.htmlPreview) {
this.htmlPreview = createElement('div', { className: 'e-content' });
this.htmlPreview.id = id;
(this.textArea as any).parentNode.appendChild(this.htmlPreview);
}
if (e.type === 'preview') {
this.textArea.style.display = 'none'; this.htmlPreview.classList.add('e-pre-source');
this.htmlPreview.style.width = '100%';
} else {
this.htmlPreview.classList.remove('e-pre-source');
this.textArea.style.width = '50%';
this.htmlPreview.style.width = '50%';
}
this.htmlPreview.style.display = 'block';
this.htmlPreview.innerHTML = marked(((this as any).defaultRTE.contentModule.getEditPanel()).value);
this.mdSource.parentElement.title = 'Code View';
}
}
public render() {
return (
<RichTextEditorComponent id="markdownRTE"
ref={(richtexteditor) => { this.rteObj = richtexteditor! }}
height='260px' editorMode='Markdown'
formatter= {this.formatter}
valueTemplate={this.template} toolbarSettings={this.toolbarSettings} >
<Inject services={[MarkdownEditor, Toolbar, Image, Link, QuickToolbar]} />
</RichTextEditorComponent>
);
}
}
export default App;
[Functional-component]
/**
* Rich Text Editor - Markdown - Custom Format Sample
*/
import { createElement } from '@syncfusion/ej2-base';
import { Image, Inject, Link, MarkdownEditor, MarkdownFormatter, QuickToolbar, RichTextEditorComponent, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
import * as React from 'react';
function App() {
let rteObj;
let mdSource;
let mdSplit;
let htmlPreview;
let defaultRTE;
let textArea;
// set the value to Rich Text Editor
let template = `The sample is configured with customized markdown syntax using the __formatter__ property. Type the content and click the toolbar item to view customized markdown syntax. For unordered list, you need to add a plus sign before the word (e.g., + list1). Or To make a phrase bold, you need to add two underscores before and after the phrase (e.g., __this text is bold__).`;
// Rich Text Editor items list
let items = ['Bold', 'Italic', 'StrikeThrough', '|',
'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', '|',
{
template: '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn">' +
'<span class="e-btn-icon e-icons e-md-preview"></span></button>',
tooltipText: 'Preview',
}, 'Undo', 'Redo'];
let mdsource;
let mdPreview;
// Rich Text Editor ToolbarSettings
let toolbarSettings = {
items: items
};
let formatter = new MarkdownFormatter({
formatTags: {
'Blockquote': '> '
},
listTags: { 'OL': '1., 2., 3.', 'UL': '+ ' },
selectionTags: { 'Bold': '__', 'Italic': '_' }
});
function markDownConversion() {
if (mdsource.classList.contains('e-active')) {
const id = rteObj.getID() + 'html-view';
const htmlPreview = rteObj.element.querySelector('#' + id);
htmlPreview.innerHTML = marked((rteObj.contentModule.getEditPanel()).value);
}
}
function fullPreview(e) {
const id = defaultRTE.getID() + 'html-preview';
htmlPreview = defaultRTE.element.querySelector('#' + id);
if ((mdSource.classList.contains('e-active') || mdSplit.classList.contains('e-active')) && e.mode) {
mdSource.classList.remove('e-active');
mdSplit.classList.remove('e-active');
mdSource.parentElement.title = 'Preview';
textArea.style.display = 'block';
textArea.style.width = '100%';
htmlPreview.style.display = 'none';
}
else {
mdSource.classList.add('e-active');
mdSplit.classList.add('e-active');
if (!htmlPreview) {
htmlPreview = createElement('div', { className: 'e-content' });
htmlPreview.id = id;
textArea.parentNode.appendChild(htmlPreview);
}
if (e.type === 'preview') {
textArea.style.display = 'none';
htmlPreview.classList.add('e-pre-source');
htmlPreview.style.width = '100%';
}
else {
htmlPreview.classList.remove('e-pre-source');
textArea.style.width = '50%';
htmlPreview.style.width = '50%';
}
htmlPreview.style.display = 'block';
htmlPreview.innerHTML = marked((defaultRTE.contentModule.getEditPanel()).value);
mdSource.parentElement.title = 'Code View';
}
}
return (<RichTextEditorComponent id="markdownRTE" ref={(richtexteditor) => { rteObj = richtexteditor; }} height='260px' editorMode='Markdown' formatter={formatter} valueTemplate={template} toolbarSettings={toolbarSettings}>
<Inject services={[MarkdownEditor, Toolbar, Image, Link, QuickToolbar]}/>
</RichTextEditorComponent>);
}
export default App;
/**
* Rich Text Editor - Markdown - Custom Format Sample
*/
import { createElement, KeyboardEventArgs } from '@syncfusion/ej2-base';
import { Image, Inject, Link, MarkdownEditor, MarkdownFormatter, QuickToolbar, RichTextEditorComponent, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
import * as React from 'react';
function App(){
let rteObj: RichTextEditorComponent;
let mdSource: HTMLElement;
let mdSplit: HTMLElement;
let htmlPreview: HTMLElement;
let defaultRTE: RichTextEditor;
let textArea: HTMLTextAreaElement;
// set the value to Rich Text Editor
let template: string = `The sample is configured with customized markdown syntax using the __formatter__ property. Type the content and click the toolbar item to view customized markdown syntax. For unordered list, you need to add a plus sign before the word (e.g., + list1). Or To make a phrase bold, you need to add two underscores before and after the phrase (e.g., __this text is bold__).`;
// Rich Text Editor items list
let items: object = ['Bold', 'Italic', 'StrikeThrough', '|',
'Formats', 'OrderedList', 'UnorderedList', '|',
'CreateLink', 'Image', '|',
{
template: '<button id="preview-code" class="e-tbar-btn e-control e-btn e-icon-btn">' +
'<span class="e-btn-icon e-icons e-md-preview"></span></button>',
tooltipText: 'Preview',
}, 'Undo', 'Redo'];
let mdsource: HTMLElement;
let mdPreview: HTMLElement;
// Rich Text Editor ToolbarSettings
let toolbarSettings: object = {
items: items
};
let formatter = new MarkdownFormatter({
formatTags: {
'Blockquote': '> '
},
listTags: { 'OL': '1., 2., 3.', 'UL': '+ ' },
selectionTags: {'Bold': '__', 'Italic': '_'}
});
function markDownConversion(): void {
if (mdsource.classList.contains('e-active')) {
const id: string = (rteObj as any).getID() + 'html-view';
const htmlPreview: HTMLElement = (rteObj as any).element.querySelector('#' + id);
htmlPreview.innerHTML = marked(((rteObj as any).contentModule.getEditPanel()).value);
}
}
function fullPreview(e: { [key: string]: string | boolean }): void {
const id: string = defaultRTE.getID() + 'html-preview';
htmlPreview = defaultRTE.element.querySelector('#' + id);
if ((mdSource.classList.contains('e-active') || mdSplit.classList.contains('e-active')) && e.mode) {
mdSource.classList.remove('e-active');
mdSplit.classList.remove('e-active');
mdSource.parentElement.title = 'Preview';
textArea.style.display = 'block';
textArea.style.width = '100%';
htmlPreview.style.display = 'none';
} else {
mdSource.classList.add('e-active');
mdSplit.classList.add('e-active');
if (!htmlPreview) {
htmlPreview = createElement('div', { className: 'e-content' });
htmlPreview.id = id;
(textArea as any).parentNode.appendChild(htmlPreview);
}
if (e.type === 'preview') {
textArea.style.display = 'none'; htmlPreview.classList.add('e-pre-source');
htmlPreview.style.width = '100%';
} else {
htmlPreview.classList.remove('e-pre-source');
textArea.style.width = '50%';
htmlPreview.style.width = '50%';
}
htmlPreview.style.display = 'block';
htmlPreview.innerHTML = marked((defaultRTE.contentModule.getEditPanel()).value);
mdSource.parentElement.title = 'Code View';
}
}
return (
<RichTextEditorComponent id="markdownRTE"
ref={(richtexteditor) => { rteObj = richtexteditor! }}
height='260px' editorMode='Markdown'
formatter= {formatter}
valueTemplate={template} toolbarSettings={toolbarSettings} >
<Inject services={[MarkdownEditor, Toolbar, Image, Link, QuickToolbar]} />
</RichTextEditorComponent>
);
}
export default App;